indexing
	description: "Event interface -- common feature between namespace and raw interfaces"
	project: "http://www.nenie.org/eiffel/"

deferred class NXML_COMMON_EVENT_INTERFACE

feature -- Actions

	when_content (a_string: STRING) is
			-- Text content within element.
		require
			not_void: a_string /= Void
		deferred
		end

	when_comment (a_content: STRING) is
			-- Comment in input.
		require
			not_void: a_content /= Void
		deferred
		end

	when_cdata (a_content: STRING) is
			-- Cdata section content.
			-- (Default action: like ordinary content)
		require
			not_void: a_content /= Void
		do
			when_content (a_content)
		end

	when_processing_instruction (a_target, a_content: STRING) is
			-- Processing instruction in input.
		require
			target: a_target /= Void
			--name: is_name (a_target)
			content: a_content /= Void
		deferred
		end

feature -- Error

	when_error (a_message: STRING) is
			-- Error has occurred.
		require
			not_void: a_message /= Void
		deferred
		end
		
end
