indexing
	description: "Nenie XML: Parser"
	project: "http://www.nenie.org/eiffel/"
	implements: "XML 1.0 (Second Edition) - W3C Recommendation 6 October 2000"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: nxml_parser.e,v 1.13 2001/07/13 20:30:59 farnaud Exp $"

deferred class NXML_PARSER

inherit
	YY_PARSER_SKELETON [ANY]
		rename
			make as make_parser,
			report_error as when_error
		undefine
			when_error
		end

	NXML_EVENT_INTERFACE

	NXML_TOKENS
		export
			{NONE} all
		end
	
	NXML_ERRORS
		export
			{NONE} all
		end
	
	KL_IMPORTED_INPUT_STREAM_ROUTINES
		export
			{NONE} all
		end
			

-- TODO:
-- character classes validation
-- pi: should have space after PI_TARGET?
-- getting error messages from scanner
-- check no external entity or DTD for standalone docs
-- xml declaration in external entities


feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate ?= yytranslate_template
			yyr1 ?= yyr1_template
			yyr2 ?= yyr2_template
			yydefact ?= yydefact_template
			yydefgoto ?= yydefgoto_template
			yypact ?= yypact_template
			yypgoto ?= yypgoto_template
			yytable ?= yytable_template
			yycheck ?= yycheck_template
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval1: NXML_PARSER_NAME
			yyval2: DS_HASH_SET [NXML_PARSER_NAME]
			yyval3: STRING
			yyval4: NXML_ENTITY_DEF
		do
			inspect yy_act
when 2 then
--|#line 129

			yyval1 := new_namespace_name
			yyval1.force_last (yytype3 (yyvs.item (yyvsp)))
		
			yyval := yyval1
when 3 then
--|#line 134

			yyval1 := new_namespace_name
			yyval1.force_last (empty_string)
		
			yyval := yyval1
when 4 then
--|#line 139

			yyval1 := yytype1 (yyvs.item (yyvsp - 2))
			yyval1.force_last (yytype3 (yyvs.item (yyvsp)))
		
			yyval := yyval1
when 5 then
--|#line 144

			yyval1 := yytype1 (yyvs.item (yyvsp - 1))
			yyval1.force_last (empty_string)
		
			yyval := yyval1
when 6 then
--|#line 151

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 7 then
--|#line 152

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 8 then
--|#line 155

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 9 then
--|#line 156

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 10 then
--|#line 163

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 11 then
--|#line 164

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 12 then
--|#line 165

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 13 then
--|#line 166

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 14 then
--|#line 167

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 15 then
--|#line 168

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 16 then
--|#line 169

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 17 then
--|#line 170

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 18 then
--|#line 171

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 19 then
--|#line 172

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 20 then
--|#line 173

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 21 then
--|#line 174

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 22 then
--|#line 175

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 23 then
--|#line 176

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 24 then
--|#line 177

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 30 then
--|#line 189
			yyval := yyval_default;
			-- really applies only in DTD, but token cannot appear in content
			-- and test above would catch, if unintentionally.
			if not in_external_dtd then 
				force_error	(Error_doctype_peref_only_in_dtd) 
			end 
		

when 31 then
--|#line 201

yyval3 := empty_string 
			yyval := yyval3
when 32 then
--|#line 203

yyval3 := yytype3 (yyvs.item (yyvsp - 1)) 
			yyval := yyval3
when 33 then
--|#line 207

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 34 then
--|#line 209

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 35 then
--|#line 211

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 36 then
--|#line 213

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 37 then
--|#line 217

yyval3 := entity_referenced_in_entity_value (yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 38 then
--|#line 223

yyval3 := empty_string 
			yyval := yyval3
when 39 then
--|#line 225

yyval3 := yytype3 (yyvs.item (yyvsp - 1)) 
			yyval := yyval3
when 40 then
--|#line 229

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 41 then
--|#line 231

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 42 then
--|#line 235

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 43 then
--|#line 236

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 44 then
--|#line 237

force_error (Error_lt_not_allowed_attribute_value) 
			yyval := yyval3
when 45 then
--|#line 240

yyval3 := empty_string 
			yyval := yyval3
when 46 then
--|#line 245
			yyval := yyval_default;
when_comment (yytype3 (yyvs.item (yyvsp - 1))) 

when 47 then
--|#line 247
			yyval := yyval_default;
when_comment (empty_string) 

when 48 then
--|#line 251

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 49 then
--|#line 253

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 50 then
--|#line 257

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 51 then
--|#line 258

force_error (Error_no_dash_dash_in_comment) 
			yyval := yyval3
when 52 then
--|#line 263
			yyval := yyval_default;
when_processing_instruction (yytype3 (yyvs.item (yyvsp - 4)), concatenate (yytype3 (yyvs.item (yyvsp - 2)),yytype3 (yyvs.item (yyvsp - 1)))) 

when 53 then
--|#line 265
			yyval := yyval_default;
when_processing_instruction (yytype3 (yyvs.item (yyvsp - 3)), concatenate (yytype3 (yyvs.item (yyvsp - 1)),yytype3 (yyvs.item (yyvsp)))) 

when 54 then
--|#line 267
			yyval := yyval_default;
when_processing_instruction (yytype3 (yyvs.item (yyvsp - 2)), empty_string) 

when 55 then
--|#line 269
			yyval := yyval_default;
force_error (Error_pi_xml_reserved) 

when 56 then
--|#line 272

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 57 then
--|#line 274

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 58 then
--|#line 278

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 59 then
--|#line 279

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 60 then
--|#line 280

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 61 then
--|#line 283

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 62 then
--|#line 284

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 63 then
--|#line 289
			yyval := yyval_default;
when_cdata (empty_string) 

when 64 then
--|#line 291
			yyval := yyval_default;
when_cdata (yytype3 (yyvs.item (yyvsp - 1))) 

when 65 then
--|#line 295

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 66 then
--|#line 297

yyval3 := concatenate (yytype3 (yyvs.item (yyvsp - 1)), yytype3 (yyvs.item (yyvsp))) 
			yyval := yyval3
when 79 then
--|#line 325
			yyval := yyval_default;
force_error (Error_xml_declaration) 

when 91 then
--|#line 349
			yyval := yyval_default;
			debug ("nxml") io.put_string ("[dtd: in]") end
			in_external_dtd := True
			when_external_dtd (yytype3 (yyvs.item (yyvsp - 3))) 
		

when 92 then
--|#line 358
			yyval := yyval_default;
			if not in_external_dtd then
				force_error (Error_misplaced_dtd_declaration)
			end
			debug ("nxml") io.put_string ("[dtd: out]") end
			in_external_dtd := False
		

when 112 then
--|#line 403
			yyval := yyval_default;
stand_alone := True 

when 113 then
--|#line 404
			yyval := yyval_default;
stand_alone := False 

when 115 then
--|#line 410
			yyval := yyval_default;
if not (yytype1 (yyvs.item (yyvsp - 1))).is_equal (yytype1 (yyvs.item (yyvsp))) then force_error (Error_end_tag_mismatch) end 

when 116 then
--|#line 412
			yyval := yyval_default;
if not (yytype1 (yyvs.item (yyvsp - 2))).is_equal (yytype1 (yyvs.item (yyvsp))) then force_error (Error_end_tag_mismatch) end 

when 117 then
--|#line 414
			yyval := yyval_default;
force_error (Error_element_end_tag) 

when 118 then
--|#line 415
			yyval := yyval_default;
force_error (Error_element_content) 

when 119 then
--|#line 421

			yyval1 := yytype1 (yyvs.item (yyvsp - 1))
			when_start_tag_end
		
			yyval := yyval1
when 120 then
--|#line 426

			yyval1 := yytype1 (yyvs.item (yyvsp - 3))
			when_start_tag_end
		
			yyval := yyval1
when 121 then
--|#line 431

force_error (Error_start_tag) 
			yyval := yyval1
when 122 then
--|#line 434
			yyval := yyval_default;
			when_start_tag_end -- makes empty attributes
			when_end_tag (yytype1 (yyvs.item (yyvsp - 1)))
		

when 123 then
--|#line 439
			yyval := yyval_default;
			when_start_tag_end
			when_end_tag (yytype1 (yyvs.item (yyvsp - 3)))
		

when 124 then
--|#line 446

			yyval1 := yytype1 (yyvs.item (yyvsp))
			when_start_tag (yytype1 (yyvs.item (yyvsp)))
		
			yyval := yyval1
when 125 then
--|#line 453

			yyval2 := new_name_set
			yyval2.force_new (yytype1 (yyvs.item (yyvsp)))
		
			yyval := yyval2
when 126 then
--|#line 458

			yyval2 := yytype2 (yyvs.item (yyvsp - 2))
			if (yyval2).has (yytype1 (yyvs.item (yyvsp))) then
				force_error (Error_attribute_duplicate)
			else
				yyval2.force_new (yytype1 (yyvs.item (yyvsp)))
			end
		
			yyval := yyval2
when 127 then
--|#line 469

			yyval1 := yytype1 (yyvs.item (yyvsp - 2))
			when_start_tag_attribute (yytype1 (yyvs.item (yyvsp - 2)), yytype3 (yyvs.item (yyvsp))) 
		
			yyval := yyval1
when 128 then
--|#line 474

force_error (Error_attribute) 
			yyval := yyval1
when 129 then
--|#line 478

			yyval1 := yytype1 (yyvs.item (yyvsp - 1))
			when_end_tag (yytype1 (yyvs.item (yyvsp - 1)))
		
			yyval := yyval1
when 130 then
--|#line 483

force_error (Error_end_tag) 
			yyval := yyval1
when 133 then
--|#line 490
			yyval := yyval_default;
when_content (yytype3 (yyvs.item (yyvsp))) 

when 138 then
--|#line 495
			yyval := yyval_default;
force_error (Error_no_cdata_end_in_content) 

when 141 then
--|#line 500
			yyval := yyval_default;
force_error (Error_entity_xml_declaration) 

when 142 then
--|#line 503

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 143 then
--|#line 505

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 145 then
--|#line 512
			yyval := yyval_default;
force_error (Error_doctype_element) 

when 182 then
--|#line 587
			yyval := yyval_default;
force_error (Error_doctype_attribute) 

when 186 then
--|#line 595
			yyval := yyval_default;
force_error (Error_doctype_attribute_item) 

when 211 then
--|#line 640
			yyval := yyval_default;
force_error (Error_doctype_conditional_section) 

when 216 then
--|#line 653
			yyval := yyval_default;
scanner.push_start_condition_dtd_ignore 

when 225 then
--|#line 677
			yyval := yyval_default;
force_error (Error_doctype_entity) 

when 226 then
--|#line 680
			yyval := yyval_default;
when_entity_declared (yytype3 (yyvs.item (yyvsp - 3)), yytype4 (yyvs.item (yyvsp - 1))) 

when 227 then
--|#line 684
			yyval := yyval_default;
when_pe_entity_declared (yytype3 (yyvs.item (yyvsp - 3)), yytype4 (yyvs.item (yyvsp - 1))) 

when 228 then
--|#line 688

yyval4 := new_literal_entity (yytype3 (yyvs.item (yyvsp - 1))) 
			yyval := yyval4
when 229 then
--|#line 690

yyval4 := new_external_entity (yytype3 (yyvs.item (yyvsp - 1))) 
			yyval := yyval4
when 231 then
--|#line 695

yyval4 := new_literal_entity (yytype3 (yyvs.item (yyvsp - 1))) 
			yyval := yyval4
when 232 then
--|#line 697

yyval4 := new_external_entity (yytype3 (yyvs.item (yyvsp - 1))) 
			yyval := yyval4
when 233 then
--|#line 701

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
when 238 then
--|#line 719
			yyval := yyval_default;
force_error (Error_xml_declaration) 

when 242 then
--|#line 729
			yyval := yyval_default;
force_error (Error_doctype_notation) 

when 243 then
--|#line 732

yyval3 := yytype3 (yyvs.item (yyvsp)) 
			yyval := yyval3
			else
					-- No action
				yyval := yyval_default
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78>>)
		end

	yyr1_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,  106,   79,   79,   79,   79,   85,   85,   86,   86,
			   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
			   87,   87,   87,   87,   87,  110,  110,  111,  111,  112,
			  112,   88,   88,   89,   89,   89,   89,   94,   90,   90,
			   91,   91,   92,   92,   92,   93,  113,  113,   95,   95,
			   96,   96,  114,  114,  114,  114,   98,   98,   99,   99,
			   99,   97,   97,  115,  115,  100,  100,  107,  116,  116,
			  116,  117,  117,  117,  109,  109,  119,  119,  118,  118,
			  123,  123,  123,  123,  122,  121,  121,  121,  120,  120,
			  126,  127,  128,  131,  131,  132,  132,  133,  133,  129,

			  129,  129,  136,  136,  134,  134,  134,  134,  134,  134,
			  134,  134,  124,  124,  108,  108,  108,  108,  108,   81,
			   81,   81,  141,  141,   80,   84,   84,   83,   83,   82,
			   82,  142,  142,  143,  143,  143,  143,  143,  143,  143,
			  144,  144,  101,  101,  137,  137,  145,  145,  145,  145,
			  147,  147,  147,  147,  151,  151,  151,  151,  151,  151,
			  149,  149,  149,  148,  155,  155,  150,  157,  157,  146,
			  146,  146,  160,  160,  152,  153,  154,  158,  156,  159,
			  138,  138,  138,  161,  161,  162,  162,  163,  163,  163,
			  165,  165,  165,  165,  165,  165,  165,  166,  166,  167,

			  169,  169,  168,  170,  170,  164,  164,  164,  164,  135,
			  135,  135,  171,  171,  173,  172,  174,  175,  175,  176,
			  176,  177,  177,  139,  139,  139,  178,  179,  102,  102,
			  102,  103,  103,  104,  180,  130,  130,  130,  130,  125,
			  140,  140,  140,  105>>)
		end

	yyr2_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    0,    3,    1,    1,    3,    2,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    0,    1,    1,    2,    1,
			    1,    2,    3,    1,    1,    2,    2,    1,    2,    3,
			    1,    2,    1,    1,    1,    1,    3,    2,    1,    2,
			    1,    1,    6,    5,    4,    1,    1,    2,    1,    1,
			    1,    1,    1,    2,    3,    1,    2,    2,    1,    1,
			    2,    0,    1,    2,    0,    1,    1,    2,    4,    2,
			    1,    3,    3,    5,    1,    1,    1,    1,    1,    2,
			    6,    8,    4,    0,    1,    1,    2,    1,    1,    0,

			    3,    4,    1,    2,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    2,    3,    3,    2,    3,
			    5,    2,    3,    5,    1,    1,    3,    3,    2,    3,
			    2,    1,    2,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    6,    2,    2,    2,    2,    1,
			    2,    2,    2,    2,    1,    2,    2,    2,    2,    2,
			    2,    2,    2,    5,    1,    3,    3,    1,    3,    3,
			    4,    6,    1,    3,    2,    2,    2,    2,    1,    2,
			    5,    6,    2,    1,    2,    6,    3,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    5,

			    1,    3,    3,    2,    4,    1,    1,    3,    1,    1,
			    1,    2,    2,    3,    5,    3,    5,    0,    1,    1,
			    2,    1,    3,    1,    1,    2,    6,    8,    2,    2,
			    3,    2,    2,    1,    4,    0,    4,    6,    2,    1,
			    7,    7,    2,    1>>)
		end

	yydefact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   74,    0,   55,    0,    0,   87,    0,   68,   85,   86,
			   71,   69,   75,   76,   84,   79,   25,   25,   51,   47,
			   50,    0,   48,    0,    0,   74,  114,    0,   67,   72,
			   88,    0,   70,   77,   30,   29,   80,   26,   27,    0,
			    0,   26,   46,   49,    3,    2,  121,  124,    0,  138,
			  140,    0,    0,  141,  142,  143,  118,  115,  133,  135,
			  137,  136,  134,    0,  131,  139,    1,    0,   73,  235,
			   89,  239,  113,  112,   28,   25,   25,   78,   54,   62,
			   61,    0,    5,  119,  122,    0,  130,    0,   63,   65,
			    0,  117,  116,  132,   24,   23,   22,   19,   18,   17,

			   16,   15,   14,   13,   12,   11,   21,   20,   10,   25,
			    0,   93,   81,   26,   82,   26,   53,   59,   58,   60,
			    0,   56,    6,    7,    4,    0,  125,    0,  129,   64,
			   66,   99,   26,  238,    0,   25,    0,  111,    0,    0,
			    0,    0,  110,  109,  108,    0,   94,   95,   97,   98,
			  104,  105,  106,  107,  209,  210,    0,  217,  223,  224,
			   25,   52,   57,    0,  128,  120,  123,    0,    0,    0,
			  233,   25,    0,    0,  211,    0,  242,    0,  225,    0,
			  182,    0,  145,    0,   92,   96,  212,    0,  217,  221,
			    0,  218,  219,   83,    0,  127,  126,   25,  102,    0,

			   90,   99,   25,  236,   25,   25,    0,    0,    0,   25,
			    0,  213,    0,  215,  220,   44,   45,   38,   42,    0,
			   40,   43,  100,   25,  103,    0,    0,    0,    0,    0,
			    0,    0,    0,   26,   25,  183,    0,  222,   39,   41,
			  101,   91,  237,  214,  216,  243,   25,   25,    0,    0,
			   25,    0,   25,  180,    0,    0,  184,   25,   25,   25,
			    0,   25,  149,   25,   25,    0,    0,    0,    0,   31,
			   37,   33,    0,   34,  228,  226,  229,   26,   25,  186,
			    0,  181,  175,  147,  146,  144,  148,   25,   25,   25,
			  150,  151,  152,  153,   25,   25,   25,   25,  167,  154,

			    0,    0,    0,  240,  241,   25,    0,   25,   32,   35,
			   36,    0,  230,    0,  196,  195,  194,  193,  192,  191,
			  190,  187,    0,    0,  188,  189,  197,  198,  161,  160,
			  162,  179,  174,  155,  156,  157,  158,  159,   25,    0,
			   25,  178,  166,    0,    0,  169,  231,  227,  232,    0,
			    0,    9,   25,    8,    0,    0,  176,  164,    0,  177,
			  168,   25,  172,    0,  170,  234,    0,  203,    0,  202,
			    0,  206,  205,  208,  185,    0,  163,    0,    0,  200,
			    0,   25,    0,  165,  173,  171,  199,    0,  204,  207,
			  201,    0,    0,    0>>)
		end

	yydefgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  125,   48,   24,   57,  126,  127,  124,  352,  295,  250,
			  272,  195,  219,  220,  221,  273,   21,   22,   81,  120,
			  121,   90,   58,  251,  306,  171,  247,  391,    6,   59,
			    7,  332,  113,   38,    8,    9,   62,   10,   28,   11,
			   12,   29,   13,   16,   39,   75,   76,   30,   31,   70,
			  169,  111,  145,  146,  147,  148,  149,  199,  150,  151,
			  152,  153,   26,   63,   64,   65,  260,  261,  262,  296,
			  291,  297,  298,  299,  300,  339,  358,  342,  301,  343,
			  302,  363,  234,  235,  323,  374,  324,  325,  326,  327,
			  380,  354,  154,  155,  156,  157,  190,  191,  192,  158,

			  159,  278>>)
		end

	yypact_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			  335,  204, -32768,  307,  352, -32768,  251, -32768, -32768, -32768,
			  292,  346,  346, -32768, -32768, -32768,  126,  126, -32768, -32768,
			 -32768,  291, -32768,   32,   24,  346, -32768,  126, -32768,  346,
			 -32768,  286,  346, -32768, -32768, -32768, -32768,  157, -32768,  277,
			  290,  221, -32768, -32768, -32768, -32768, -32768,  227,   49, -32768,
			 -32768,   17,  253, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,    6, -32768, -32768, -32768,  350,  346,  275,
			 -32768, -32768, -32768, -32768, -32768,  126,  126, -32768, -32768, -32768,
			 -32768,  419,  304, -32768, -32768,   -2, -32768,  -20, -32768, -32768,
			  210, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  126,
			   22,  578, -32768,  126, -32768,  238, -32768, -32768, -32768, -32768,
			  417, -32768, -32768, -32768, -32768,   10, -32768,   44, -32768, -32768,
			 -32768,  233,  240, -32768,  126,  126,   77, -32768,  163,  155,
			  153,  123, -32768, -32768, -32768,  262,  578, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,  571,   40, -32768, -32768,
			  126, -32768, -32768,  222, -32768, -32768, -32768,   -2,  639,  255,
			 -32768,  126,  218,  254, -32768,  305, -32768,  350, -32768,  416,
			 -32768,  350, -32768,  350, -32768, -32768, -32768,  567,   40, -32768,
			  199,   40, -32768, -32768,   34, -32768, -32768,  126, -32768,  611,

			 -32768,  233,  126, -32768,  126,  126,  126,  126,  126,  126,
			  126, -32768,  177, -32768, -32768, -32768, -32768, -32768, -32768,    1,
			 -32768, -32768, -32768,  126, -32768,  213,  192,  166,   56,  184,
			  350,  101,  211,  350,  126, -32768,  167, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,  126,  126,  126,   57,
			  126,  205,  126, -32768,   15,  188, -32768,  126,  126,  126,
			  182,  126, -32768,  164,  164,  450,  138,  128,  101, -32768,
			 -32768, -32768,   46, -32768, -32768, -32768, -32768,   82,  126, -32768,
			  339, -32768, -32768, -32768, -32768, -32768, -32768,  126,  126,  126,
			 -32768, -32768, -32768, -32768,  126,  164,  164,  164,  115, -32768,

			  280,   92,  313, -32768, -32768,  126,  124,  126, -32768, -32768,
			 -32768,  126, -32768,  126, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,  478,  126, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  126,  280,
			  126, -32768, -32768,  280,  512,   85, -32768, -32768, -32768,  350,
			  154, -32768,  126, -32768,  313,  102, -32768, -32768,  313, -32768,
			 -32768,  126, -32768,  313, -32768, -32768,  512, -32768,  478, -32768,
			  126, -32768, -32768, -32768, -32768,  280, -32768,  512,   19, -32768,
			  250,  126,   30, -32768, -32768, -32768, -32768,  512, -32768, -32768,
			 -32768,   43,   29, -32768>>)
		end

	yypgoto_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			    5, -32768, -32768,  349,  244, -32768, -32768,   45,   72,  139,
			 -32768, -321, -32768,  165, -32768,  111, -32768,  361, -32768, -32768,
			  260, -32768, -32768, -32768, -32768, -205, -32768, -32768, -32768,  373,
			  351,  -16,   58,  137,  -15,  -19, -32768, -32768, -32768, -32768,
			    8, -32768,   83,  245, -32768,  243, -107, -32768, -32768, -32768,
			  143, -32768, -32768,  195, -136,  -28, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768,  274, -32768, -32768, -32768, -32768,  106,
			  -81,   99,  -80,  -90, -234, -296, -32768, -233, -32768, -32768,
			 -32768, -32768, -32768,   91, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,  135, -32768,  130, -32768,

			 -32768, -32768>>)
		end

	yytable_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   36,   40,  265,  135,   35,   61,  344,   91,  218,   60,
			  185,  164,   55,   54,    4,  163,  279,    3,   86,   32,
			    2,   35,   53,  133,  246,   56,  252,   52,   47,  393,
			   55,   54,    4,   46,  373,    3,   35,   68,    2,   14,
			   53,  218,   71,  392,   61,   52,  322,  189,   60,  128,
			   35,  185,   82,  309,   34,   35,   87,  385,  368,  112,
			  114,  389,  375,  307,  271,  202,  238,  377,   45,  345,
			   44,   34,   23,   51,   37,   41,  216,  215,  174,   50,
			   49,  244,   82,   35,  387,   67,   34,   45,   35,   44,
			   23,   51,  144,  131,  194,   33,  143,   50,   49,  217,

			   34,  188,   45,  270,   44,   34,   85,   35,   35,  216,
			  215,  308,  166,  165,  270,   33,  366,   84,   83,  173,
			  175,  369,  269,  364,  182,  376,  341,  144,  340,   35,
			  378,  143,   35,   34,  115,  -25,  -25,  144,   34,  109,
			  198,  143,  311,  170,  193,  372,  371,  370,  347,  144,
			  338,   33,  304,  143,  180,  201,  178,   34,   34,   35,
			   35,   35,  303,   35,  176,  249,  194,  132,  144,   35,
			   35,  224,  143,   35,   74,   73,   72,   71,   74,   34,
			  144,  222,   34,  293,  143,  167,  226,  257,  227,  228,
			   35,  243,  172,  232,  259,  258,  177,  179,  181,  183,

			  257,  289,  288,  287,   74,   15,  285,  240,  242,   34,
			   34,   34,  281,   34,  333,  335,  337,  130,  255,   34,
			   34,   14,   74,   34,   35,  245,  170,   35,   80,  275,
			  266,  267,  129,   79,  274,  253,  276,  241,   71,  237,
			   34,  282,  283,  284,   35,  286,   35,  290,  292,  206,
			   74,  208,   74,  209,  362,  210,   73,   72,  168,  357,
			   89,  213,  312,  360,  229,  230,  231,  233,  236,   74,
			  203,  328,  329,  330,   34,   88,  379,   34,  331,  200,
			  334,  336,  170,  108,  386,  338,  194,  384,  184,  346,
			  110,  348,  233,   77,   34,  383,   34,  390,   20,   82,

			   42,   18,  248,   78,   74,  254,  268,  107,  106,   74,
			  277,   69,  280,  257,   74,   27,   74,   23,   74,   17,
			   74,  214,  356,  212,  359,  256,  105,  104,  103,  102,
			  101,  100,   99,   98,   97,  264,  367,   93,   96,   95,
			   94,    5,  263,    4,  225,   35,    3,  341,  338,    2,
			    1,  187,    5,  108,    4,  134,   35,    3,  160,   20,
			    2,   19,   18,  205,  204,  388,   74,   74,   74,  349,
			   74,  350,  257,   74,  123,  122,   66,  107,  106,   25,
			  162,  355,   43,  310,  239,  321,  320,  319,  318,  317,
			  316,  315,  314,  313,  353,   34,  105,  104,  103,  102,

			  101,  100,   99,   98,   97,   74,   34,  305,   96,   95,
			   94,  196,   92,  381,   74,    0,  361,   74,    0,  108,
			    0,  365,   35,  119,  118,  119,  118,    0,  382,  117,
			  161,  117,  116,    0,    0,    0,    0,    0,  361,    0,
			  353,    0,    0,  107,  106,    0,    0,    0,    0,  361,
			    0,    0,    0,  108,    0,    0,    0,    0,    0,  361,
			    0,    0,  105,  104,  103,  102,  101,  100,   99,   98,
			   97,  207,   34,    0,   96,   95,   94,  107,  106,    0,
			    0,  108,  351,  257,    0,    0,   74,   74,    0,    0,
			  294,    0,   74,    0,    0,    0,  105,  104,  103,  102,

			  101,  100,   99,   98,   97,  107,  106,    0,   96,   95,
			   94,    0,    0,    0,    0,  108,    0,    0,    0,   74,
			    0,    0,    0,    0,  105,  104,  103,  102,  101,  100,
			   99,   98,   97,    0,    0,    0,   96,   95,   94,  107,
			  106,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  105,  104,
			  103,  102,  101,  100,   99,   98,   97,    0,    0,    0,
			   96,   95,   94,  142,    0,    4,    0,  142,    3,    4,
			    0,    2,    3,    0,  142,    2,    4,    0,    0,    3,
			    0,    0,    2,    0,    0,    0,  141,  140,  139,  138,

			  141,  140,  139,  138,    0,    0,    0,  141,  140,  139,
			  138,    0,    0,    0,    0,    0,    0,  142,    0,    4,
			    0,    0,    3,  137,    0,    2,    0,  137,  136,  211,
			    0,    0,  136,  186,  137,    0,    0,  223,    0,  136,
			  141,  140,  139,  138,    0,  142,    0,    4,    0,    0,
			    3,    0,    0,    2,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  197,    0,  137,  141,  140,
			  139,  138,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  137>>)
		end

	yycheck_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yyfixed_array (<<
			   16,   17,  236,  110,    6,   24,  302,    1,    7,   24,
			  146,    1,    6,    7,    8,    5,    1,   11,    1,   11,
			   14,    6,   16,    1,  229,    1,  231,   21,   23,    0,
			    6,    7,    8,    1,  355,   11,    6,   29,   14,   17,
			   16,    7,   20,    0,   63,   21,  280,    7,   63,   69,
			    6,  187,   72,    7,   56,    6,   51,   38,  354,   75,
			   76,  382,  358,  268,    7,  172,   65,  363,   70,  302,
			   72,   56,   66,   67,   16,   17,   75,   76,    1,   73,
			   74,   25,   72,    6,  380,   27,   56,   70,    6,   72,
			   66,   67,  111,  109,   64,   12,  111,   73,   74,   65,

			   56,   61,   70,   57,   72,   56,   48,    6,    6,   75,
			   76,   65,   68,   69,   57,   32,  350,   68,   69,  135,
			  136,  354,   65,   38,    1,  358,   34,  146,   36,    6,
			  363,  146,    6,   56,   76,   58,   59,  156,   56,   67,
			  168,  156,   60,   42,  160,   43,   44,   45,   24,  168,
			   35,   68,   24,  168,    1,  171,    1,   56,   56,    6,
			    6,    6,   24,    6,    1,   64,   64,  109,  187,    6,
			    6,  199,  187,    6,   37,   18,   19,   20,   41,   56,
			  199,  197,   56,  264,  199,  127,  202,   33,  204,  205,
			    6,   25,  134,  209,   27,   28,  138,  139,  140,  141,

			   33,   37,   38,   39,   67,    1,   24,  223,   16,   56,
			   56,   56,   24,   56,  295,  296,  297,    7,  234,   56,
			   56,   17,   85,   56,    6,   41,   42,    6,    7,   24,
			  246,  247,   22,   12,  250,   24,  252,   24,   20,   62,
			   56,  257,  258,  259,    6,  261,    6,  263,  264,  177,
			  113,  179,  115,  181,  344,  183,   18,   19,   25,  339,
			    7,   62,  278,  343,  206,  207,  208,  209,  210,  132,
			   16,  287,  288,  289,   56,   22,  366,   56,  294,   24,
			  296,  297,   42,    3,   34,   35,   64,  377,   26,  305,
			   15,  307,  234,   16,   56,  375,   56,  387,    7,   72,

			    9,   10,  230,   13,  167,  233,  248,   27,   28,  172,
			  252,   25,  254,   33,  177,   23,  179,   66,  181,   12,
			  183,  191,  338,  188,  340,  234,   46,   47,   48,   49,
			   50,   51,   52,   53,   54,  236,  352,   63,   58,   59,
			   60,    6,  236,    8,  201,    6,   11,   34,   35,   14,
			   15,  156,    6,    3,    8,  110,    6,   11,  115,    7,
			   14,    9,   10,   58,   59,  381,  229,  230,  231,  311,
			  233,  313,   33,  236,   70,   71,   25,   27,   28,    6,
			  120,  323,   21,  272,  219,   46,   47,   48,   49,   50,
			   51,   52,   53,   54,  322,   56,   46,   47,   48,   49,

			   50,   51,   52,   53,   54,  268,   56,  268,   58,   59,
			   60,  167,   63,  368,  277,   -1,  344,  280,   -1,    3,
			   -1,  349,    6,    6,    7,    6,    7,   -1,  370,   12,
			   13,   12,   13,   -1,   -1,   -1,   -1,   -1,  366,   -1,
			  368,   -1,   -1,   27,   28,   -1,   -1,   -1,   -1,  377,
			   -1,   -1,   -1,    3,   -1,   -1,   -1,   -1,   -1,  387,
			   -1,   -1,   46,   47,   48,   49,   50,   51,   52,   53,
			   54,   55,   56,   -1,   58,   59,   60,   27,   28,   -1,
			   -1,    3,    4,   33,   -1,   -1,  349,  350,   -1,   -1,
			   40,   -1,  355,   -1,   -1,   -1,   46,   47,   48,   49,

			   50,   51,   52,   53,   54,   27,   28,   -1,   58,   59,
			   60,   -1,   -1,   -1,   -1,    3,   -1,   -1,   -1,  382,
			   -1,   -1,   -1,   -1,   46,   47,   48,   49,   50,   51,
			   52,   53,   54,   -1,   -1,   -1,   58,   59,   60,   27,
			   28,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   46,   47,
			   48,   49,   50,   51,   52,   53,   54,   -1,   -1,   -1,
			   58,   59,   60,    6,   -1,    8,   -1,    6,   11,    8,
			   -1,   14,   11,   -1,    6,   14,    8,   -1,   -1,   11,
			   -1,   -1,   14,   -1,   -1,   -1,   29,   30,   31,   32,

			   29,   30,   31,   32,   -1,   -1,   -1,   29,   30,   31,
			   32,   -1,   -1,   -1,   -1,   -1,   -1,    6,   -1,    8,
			   -1,   -1,   11,   56,   -1,   14,   -1,   56,   61,   62,
			   -1,   -1,   61,   62,   56,   -1,   -1,   26,   -1,   61,
			   29,   30,   31,   32,   -1,    6,   -1,    8,   -1,   -1,
			   11,   -1,   -1,   14,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   26,   -1,   56,   29,   30,
			   31,   32,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   56>>)
		end

feature {NONE} -- Conversion

	yytype1 (v: ANY): NXML_PARSER_NAME is
		require
			valid_type: yyis_type1 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type1 (v: ANY): BOOLEAN is
		local
			u: NXML_PARSER_NAME
		do
			u ?= v
			Result := (u = v)
		end

	yytype2 (v: ANY): DS_HASH_SET [NXML_PARSER_NAME] is
		require
			valid_type: yyis_type2 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type2 (v: ANY): BOOLEAN is
		local
			u: DS_HASH_SET [NXML_PARSER_NAME]
		do
			u ?= v
			Result := (u = v)
		end

	yytype3 (v: ANY): STRING is
		require
			valid_type: yyis_type3 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type3 (v: ANY): BOOLEAN is
		local
			u: STRING
		do
			u ?= v
			Result := (u = v)
		end

	yytype4 (v: ANY): NXML_ENTITY_DEF is
		require
			valid_type: yyis_type4 (v)
		do
			Result ?= v
		ensure
			definition: Result = v
		end

	yyis_type4 (v: ANY): BOOLEAN is
		local
			u: NXML_ENTITY_DEF
		do
			u ?= v
			Result := (u = v)
		end


feature {NONE} -- Constants

	yyFinal: INTEGER is 393
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 79
			-- Number of tokens

	yyLast: INTEGER is 695
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 333
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 181
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features


feature {NONE} -- creation

	make is
			-- Initialise.
		do
			make_scanner
			make_parser

			-- parser state
			stand_alone := False
			in_external_dtd := False
			
			-- entities
			!! entities.make_default
			!! pe_entities.make_default
		end

	-- reset?

feature {NONE} -- State

	stand_alone: BOOLEAN
			-- From XML declaration.

	entities: DS_HASH_TABLE [NXML_ENTITY_DEF,STRING]
			-- Defined entites
	pe_entities: DS_HASH_TABLE [NXML_ENTITY_DEF,STRING]
			-- Defined PE entities
	
	in_external_dtd: BOOLEAN
			-- Is the scanner in an external DTD?
		
feature {NONE} -- Factory

	new_namespace_name: NXML_PARSER_NAME is
			-- Create namespace_name.
		do
			!! Result.make
		ensure
			new_object: Result /= Void
			empty: Result.is_empty
		end
		
	new_name_set: DS_HASH_SET [NXML_PARSER_NAME] is
			-- Name set for checking.
		do
			!! Result.make_equal (0)
		end

feature {NONE} -- Entitties

	new_literal_entity (a_value: STRING): NXML_ENTITY_DEF is
			-- New literal entity definition.
		require
			not_void: a_value /= Void
		do
			!! Result.make_literal (a_value)
		end
		
	new_external_entity (a_value: STRING): NXML_ENTITY_DEF is
			-- New external entity definition.
		require
			not_void: a_value /= Void
		do
			!! Result.make_external (a_value)
		end
		
feature {NXML_PARSER} -- Entities

	when_entity_declared (a_name: STRING; a_def: NXML_ENTITY_DEF) is
			-- Entity has been declared.
		require
			name_not_void: a_name /= Void
		do
		 	debug ("nxml")
				io.put_string ("Entity declared: ")
				io.put_string (a_name)
				io.put_string (" value: ")
				io.put_string (a_def.value)
				io.put_new_line
			end
			
			-- 4.2: when multiple declaration first one is binding
			if a_def /= Void then
				if not entities.has (a_name) then
					entities.force (a_def, a_name)
				end
				check has: entities.has (a_name) end
			end
		end
		
	when_pe_entity_declared (a_name: STRING; in_def: NXML_ENTITY_DEF) is
			-- PE entity has been declared.
		require
			name_not_void: a_name /= Void
		local
			a_def: NXML_PE_ENTITY_DEF
		do
		 	debug ("nxml")
				io.put_string ("PE entity declared: ")
				io.put_string (a_name)
				io.put_string (" value: ")
				io.put_string (in_def.value)
				io.put_new_line
			end

			-- convert to PE
			!! a_def.make_def (in_def)
			
			-- 4.2: when multiple declaration take first one
			if a_def /= Void then
				if not pe_entities.has (a_name) then
					pe_entities.force (a_def, a_name)
				end
				check has: pe_entities.has (a_name) end
			end
		end
		
	entity_referenced_in_entity_value (a_name: STRING): STRING is
			-- Named parameter entity has been referenced in entity value.
		require
			not_void: a_name /= Void
		do
			if in_external_dtd then
				if pe_entities.has (a_name) then
					Result := defined_entity_referenced (pe_entities.item (a_name))
				else
					-- 4.4.4 Forbidden
					force_error (Error_external_reference_in_quoted_value)
				end
			else
				force_error (Error_doctype_peref_only_in_dtd)
			end
		end

	defined_entity_referenced (a_def: NXML_ENTITY_DEF): STRING is
			-- Resolved defined entity in quoted value.
		require
			not_void: a_def /= Void
		do
			if a_def.is_literal then
				-- 4.4.5 Included in literal
				Result := a_def.value
			else
				Result := external_entity_to_string (a_def.value)
			end
		end
		
	external_entity_to_string (a_sys: STRING): STRING is
			-- External entity to string.
		require
			not_void: a_sys /= Void
		local
			a_file: like INPUT_STREAM_TYPE
			an_error: STRING
		do
			!! Result.make (0)
			a_file := INPUT_STREAM_.make_file_open_read (a_sys)
			if INPUT_STREAM_.is_open_read (a_file) then
				-- inefficient?
				from until
					INPUT_STREAM_.end_of_input (a_file)
				loop
					Result.append_string (INPUT_STREAM_.read_string (a_file,100))
				end
			else
				!! an_error.make (0)
				an_error.copy (Error_cannot_read_file)
				an_error.append_string (": ")
				an_error.append_string (a_sys)
				force_error (an_error)
			end
		end
		
feature {NONE} -- DTD

	when_external_dtd (a_system: STRING) is
			-- Load external DTD from system name.
		require
			system_ok: a_system /= Void
		do
			debug ("nxml") io.put_string ("[when_external_dtd]") end
			
			-- push old scanner
			scanners.force (scanner)
			!NXML_SCANNER_DTD! scanner.make_scanner
			scanner.set_input_file (a_system)
			if not scanner.last_input_file_opened then
				when_error (Error_cannot_open_external_dtd)
			end
		end

feature -- Parser

	parse_file (a_name: STRING) is
			-- Parse file.
		require
			not_void: a_name /= Void
		do
			scanner.set_input_file (a_name)
			if scanner.last_input_file_opened then
				parse
			else
				force_error (Error_cannot_read_file)
			end
		end
		
	parse_string (a_string: STRING) is
			-- Parse string.
		require
			not_void: a_string /= Void
		do
			scanner.set_input_buffer (scanner.new_string_buffer (a_string))
			parse
		end
		
feature -- Errors
	
	force_error (a_message: STRING) is
			-- Report error message.
		do
			when_error (a_message)
			abort
		end

feature {NONE} -- Scanner implementation

	make_scanner is
			-- Initialise main scanner and saved
			-- scannners stack.
		do
			!NXML_SCANNER! scanner.make_scanner
			!! scanners.make
		end
		
	scanner: NXML_SCANNER
			-- Scanner for PE entity.

	scanners: DS_LINKED_STACK[NXML_SCANNER]
			-- Scanner stack for entities etc.

	last_token: INTEGER
			-- Last token read by read_token.
	last_value: ANY
			-- Last value read by read_token.
	
	read_token is
			-- Read token from scanner.
		do
			-- read token from scanner
			scanner.read_token
			last_token := scanner.last_token
			last_value := scanner.last_value
			
			debug ("nxml")
				io.put_string (token_name (last_token))
				io.put_string ("/")
				if last_value /= Void then
					io.put_string (last_value.out)
					io.put_string ("!")
				end
			end
			
			-- unwind scanner stack if end of current one
			if scanner.end_of_file and not scanners.is_empty then
				scanner := scanners.item
				scanners.remove
				read_token
			end
			
			-- if this is a PE entity reference, temporarily
			-- switch scanner. Token is left for validation.
			if last_token = DOCTYPE_PEREFERENCE then
				process_pe_entity (last_value.out)
			-- same if content entity reference
			elseif last_token = CONTENT_ENTITY  then
				process_entity (last_value.out)
			elseif last_token = ATTRIBUTE_ENTITY then
				process_attribute_entity (last_value.out)
			end
		end

feature {NONE} -- Scanner entity processing

	process_pe_entity (a_name: STRING) is
			-- Pushn PE entity scanner on stack.
		require
			not_void: a_name /= Void
		do
			if pe_entities.has (a_name) then
				process_entity_scanner (pe_entities.item (a_name))
			else
				force_error (Error_doctype_undefined_pe_entity)
			end
		end
		
	process_entity (a_name: STRING) is
			-- Push entity scanner on stack.
		require
			not_void: a_name /= Void
		do
			if entities.has (a_name) then
				process_entity_scanner (entities.item (a_name))
			else
				-- 4.4.4 Forbidden
				force_error (Error_entity_undefined)
			end
		end
	
	process_attribute_entity (a_name: STRING) is
			-- Push entity scanner on stack.
		require
			not_void: a_name /= Void
		do
			if entities.has (a_name) then
				if entities.item (a_name).is_literal then
					process_entity_scanner (entities.item (a_name))
				else
					force_error (Error_entity_literal_in_attribute)
				end
			else
				-- 4.4.4 Forbidden
				force_error (Error_entity_undefined)
			end
		end
		
	process_entity_scanner (a_def: NXML_ENTITY_DEF) is
			-- Save previous scannner, create new scanner, and
			-- reset it with previous scanner state. 
		require
			not_void: a_def /= Void
		do				
			a_def.apply_input_buffer
				
			if a_def.has_error then
				force_error (a_def.last_error)
			else
				-- push scanner
				a_def.set_start_condition (scanner.start_condition)
				scanners.force (scanner)
				scanner := a_def
			end
		end

feature -- Error diagnostic

	line: INTEGER is
			-- Current line.
		do
			Result := scanner.line
		end
		
	column: INTEGER is
			-- Current column.
		do
			Result := scanner.column
		end
		
	filename: STRING is
			-- Current file.
		do
			Result := scanner.filename
		end
		
	error_header: STRING is
			-- Header for error message.
			-- <filename>:<line>:<column>:
		do
			!! Result.make (0)
			Result.append_string (filename)
			Result.append_string (":")
			Result.append_string (line.out)
			Result.append_string (":")
			Result.append_string (column.out)
			Result.append_string (":")
		ensure
			not_void: Result /= Void
		end

feature {NONE} -- String

	concatenate (a, b: STRING): STRING is
			-- Result := a + b
		require
			not_void: a /= Void and b /= Void
		do
			!! Result.make (0)
			Result.append_string (a)
			Result.append_string (b)
		end

	empty_string: STRING is
			-- Shared empty string. 
		once
			!!Result.make (0)
		end

invariant
	scanner_not_void: scanner /= Void
	scanners_not_void: scanners /= Void
		
end
