indexing
	description: "Test parser - output some pseudo-canonical XML"
	project: "http://www.nenie.org/eiffel/"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: nxml_parser_test.e,v 1.5 2001/07/13 20:35:51 farnaud Exp $"
	
class
	NXML_PARSER_TEST

inherit
	NXML_PARSER_CANONICAL
		redefine
			when_output_string,
			when_comment,
			when_error
		end
	
creation
	make

feature -- Display handling

	quiet: BOOLEAN
			-- Do not output canonical output.
			
	set_quiet (a: BOOLEAN) is
			-- Set 'quiet'
		do
			quiet := a
		end
		
	hide_errors: BOOLEAN
			-- Do not display errors.
	
	set_hide_errors (a: BOOLEAN) is
			-- Toggle errors.
		do
			hide_errors := a
		end
		
feature -- Events

	when_error (a_msg: STRING) is
			-- On error.
		do
			if not hide_errors then
				Precursor (a_msg)
			end
		end
		
	when_output_string (a_string: STRING) is
			-- Output string.
		do
			if not quiet then
				io.put_string (a_string)
			end
		end
		
	when_comment (a_content: STRING) is
			-- Comment.
		do
			Precursor (a_content)
			if not quiet then
				when_output_string ("<!--")
				when_output_string (a_content)
				when_output_string ("-->")
			end
		end

end
