
indexing
	description: "Nenie XML: a scanner for an XML parser"
	project: "http://www.nenie.org/eiffel/"
	implements: "XML 1.0 Second Edition - W3C Recommendation 6 October 2000 (referred as 'XML1.0')"
	noncompliance_unicode: "UTF8 is assumed and all chars >255 are assumed to be LETTERS"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: nxml_scanner.e,v 1.12 2001/07/13 20:40:46 farnaud Exp $"

	-- todo:
	-- system literal accepts non-CHAR
	-- use CONTENTCHAR+ for attribute value?

class NXML_SCANNER

inherit
	YY_COMPRESSED_SCANNER_SKELETON
		rename
			make as make_scanner_stdin
		redefine
			reset,
			fatal_error
		end

	NXML_TOKENS
		export
			{NONE} all
		end

	NXML_ERRORS
		export
			{NONE} all
		end
		
	KL_IMPORTED_INPUT_STREAM_ROUTINES
		export
			{NONE} all
		end
		
	NXML_UTF8_PRIVATE_ROUTINES
	
	NXML_CONVERSION_PRIVATE_ROUTINES

creation
	make_scanner


feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= dtd_ignore)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt ?= yy_nxt_template
			yy_chk ?= yy_chk_template
			yy_base ?= yy_base_template
			yy_def ?= yy_def_template
			yy_ec ?= yy_ec_template
			yy_meta ?= yy_meta_template
			yy_accept ?= yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 58 then
if yy_act <= 29 then
if yy_act <= 15 then
if yy_act <= 8 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + 4
--|#line 113
 
			set_last_token (COMMENT_START)
			push_start_condition (comment_state)
		
else
	yy_column := yy_column + 3
--|#line 121

			set_last_token (COMMENT_END)
			pop_start_condition
		
end
else
if yy_act = 3 then
	yy_column := yy_column + 2
--|#line 126
 
			set_last_token (COMMENT_DASHDASH) -- conformance error XML1.0:2.5
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 131

			set_last_token (CHARDATA)
			last_value := text
		
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
yy_set_line_column
--|#line 136

			set_last_token (CHARDATA) 
			last_value := text
		
else
yy_set_line_column
--|#line 147

			set_last_token (XMLDECLARATION_START)
			push_start_condition (xmldeclaration)
		
end
else
if yy_act = 7 then
yy_set_line_column
--|#line 152

			-- "<?xml" matched by previous rule when allowed
			set_last_token (PI_RESERVED)
		
else
	yy_column := yy_column + 2
--|#line 156

			-- <?xml caught by previous rules
			set_last_token (PI_START)
			push_start_condition (processinginstruction)
		
end
end
end
else
if yy_act <= 12 then
if yy_act <= 10 then
if yy_act = 9 then
	yy_column := yy_column + 2
--|#line 165

			set_last_token (XMLDECLARATION_END)
			pop_start_condition
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 171

			set_last_token (XMLDECLARATION_VERSION) 
		
end
else
if yy_act = 11 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 176

			set_last_token (XMLDECLARATION_STANDALONE_YES) 
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 180

			set_last_token (XMLDECLARATION_STANDALONE_NO) 
		
end
end
else
if yy_act <= 14 then
if yy_act = 13 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 184

			set_last_token (XMLDECLARATION_ENCODING)
		
else
yy_set_line_column
--|#line 188
 
			set_last_token (SPACE) 
		
end
else
	yy_column := yy_column + 2
--|#line 195

			set_last_token (PI_END)
			pop_start_condition
		
end
end
end
else
if yy_act <= 22 then
if yy_act <= 19 then
if yy_act <= 17 then
if yy_act = 16 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 199

			set_last_token (PI_TARGET)
			last_value := text
		
else
yy_set_line_column
--|#line 203

			set_last_token (SPACE)
			last_value := text
		
end
else
if yy_act = 18 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 207

			-- get more than one at a time
			set_last_token (CHARDATA)
			last_value := text
		
else
yy_set_line_column
--|#line 212
 
			set_last_token (CHARDATA) 
			last_value := text
		
end
end
else
if yy_act <= 21 then
if yy_act = 20 then
	yy_column := yy_column + 9
--|#line 220

	set_last_token (CDATA_START)
	push_start_condition (cdata)

else
	yy_column := yy_column + 3
--|#line 227
 
			set_last_token (CDATA_END) 
			pop_start_condition
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 231

			-- big chunks in last_value
			set_last_token (CHARDATA)
			last_value := text
		
end
end
else
if yy_act <= 26 then
if yy_act <= 24 then
if yy_act = 23 then
yy_set_line_column
--|#line 236
 
			set_last_token (CHARDATA) 
			last_value := text
		
else
	yy_column := yy_column + 9
--|#line 242

		set_last_token (DOCTYPE_START)
		push_start_condition (dtd_in)
	
end
else
if yy_act = 25 then
	yy_column := yy_column + 9
--|#line 249
 set_last_token (DOCTYPE_REQUIRED) 
else
	yy_column := yy_column + 8
--|#line 250
 set_last_token (DOCTYPE_IMPLIED) 
end
end
else
if yy_act <= 28 then
if yy_act = 27 then
	yy_column := yy_column + 6
--|#line 251
 set_last_token (DOCTYPE_FIXED) 
else
	yy_column := yy_column + 5
--|#line 252

			set_last_token (DOCTYPE_ATT_CDATA) 
			last_value := text
		
end
else
	yy_column := yy_column + 2
--|#line 256

			set_last_token (DOCTYPE_ATT_ID) 
			last_value := text
		
end
end
end
end
else
if yy_act <= 44 then
if yy_act <= 37 then
if yy_act <= 33 then
if yy_act <= 31 then
if yy_act = 30 then
	yy_column := yy_column + 5
--|#line 260

			set_last_token (DOCTYPE_ATT_IDREF)
			last_value := text
		
else
	yy_column := yy_column + 6
--|#line 264

			set_last_token (DOCTYPE_ATT_IDREFS)
			last_value := text
		
end
else
if yy_act = 32 then
	yy_column := yy_column + 6
--|#line 268

			set_last_token (DOCTYPE_ATT_ENTITY)
			last_value := text
		
else
	yy_column := yy_column + 8
--|#line 272

			set_last_token (DOCTYPE_ATT_ENTITIES) 
			last_value := text
		
end
end
else
if yy_act <= 35 then
if yy_act = 34 then
	yy_column := yy_column + 7
--|#line 276

			set_last_token (DOCTYPE_ATT_NMTOKEN) 
			last_value := text
		
else
	yy_column := yy_column + 8
--|#line 280

			set_last_token (DOCTYPE_ATT_NMTOKENS)
			last_value := text
		
end
else
if yy_act = 36 then
	yy_column := yy_column + 8
--|#line 284

			set_last_token (DOCTYPE_ATT_NOTATION)
			last_value := text
		
else
	yy_column := yy_column + 1
--|#line 288

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_single)
		
end
end
end
else
if yy_act <= 41 then
if yy_act <= 39 then
if yy_act = 38 then
	yy_column := yy_column + 1
--|#line 292

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_double)
		
else
	yy_column := yy_column + 1
--|#line 300

			set_last_token (DOCTYPE_DECLARATION_START)
			push_start_condition (doctype)
		
end
else
if yy_act = 40 then
	yy_column := yy_column + 1
--|#line 310

			set_last_token (DOCTYPE_DECLARATION_START)
			push_start_condition (doctype) -- same, but balances end
		
else
	yy_column := yy_column + 1
--|#line 315

			set_last_token (DOCTYPE_DECLARATION_END)
			pop_start_condition
		
end
end
else
if yy_act <= 43 then
if yy_act = 42 then
	yy_column := yy_column + 9
--|#line 320

			set_last_token (DOCTYPE_ELEMENT)
			push_start_condition (dtd_element)
		
else
	yy_column := yy_column + 9
--|#line 324

			set_last_token (DOCTYPE_ATTLIST)
			push_start_condition (dtd_attlist)
		
end
else
	yy_column := yy_column + 8
--|#line 328

			set_last_token (DOCTYPE_ENTITY)
			push_start_condition (dtd_entity)
		
end
end
end
else
if yy_act <= 51 then
if yy_act <= 48 then
if yy_act <= 46 then
if yy_act = 45 then
	yy_column := yy_column + 10
--|#line 332

			set_last_token (DOCTYPE_NOTATION)
			push_start_condition (dtd_notation)
		
else
	yy_column := yy_column + 6
--|#line 337

			set_last_token (DOCTYPE_IGNORE)
			last_value := text
		
end
else
if yy_act = 47 then
	yy_column := yy_column + 7
--|#line 342

			set_last_token (DOCTYPE_INCLUDE)
			last_value := text
		
else
	yy_column := yy_column + 3
--|#line 347

			set_last_token (DOCTYPE_CONDITIONAL_START)
		
end
end
else
if yy_act <= 50 then
if yy_act = 49 then
	yy_column := yy_column + 3
--|#line 351

			set_last_token (DOCTYPE_CONDITIONAL_END)
		
else
	yy_column := yy_column + 3
--|#line 358

			set_last_token (DOCTYPE_CONDITIONAL_START)
			push_start_condition (dtd_ignore) -- self, for exit
		
end
else
	yy_column := yy_column + 3
--|#line 363

			set_last_token (DOCTYPE_CONDITIONAL_END)
			pop_start_condition
		
end
end
else
if yy_act <= 55 then
if yy_act <= 53 then
if yy_act = 52 then
yy_set_line_column
--|#line 368

			set_last_token (CHARDATA)
		
else
	yy_column := yy_column + 7
--|#line 375
 set_last_token (DOCTYPE_PCDATA) 
end
else
if yy_act = 54 then
	yy_column := yy_column + 5
--|#line 377

			set_last_token (DOCTYPE_ELEMENT_EMPTY)
			last_value := text
		
else
	yy_column := yy_column + 3
--|#line 382

			set_last_token (DOCTYPE_ELEMENT_ANY)
			last_value := text
		
end
end
else
if yy_act <= 57 then
if yy_act = 56 then
	yy_column := yy_column + 5
--|#line 390

			set_last_token (DOCTYPE_NDATA)
			last_value := text
		
else
	yy_column := yy_column + 1
--|#line 398
 
			set_last_token (DOCTYPE_END)
			pop_start_condition
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 403
 
			set_last_token (NAME) 
			last_value := text
		
end
end
end
end
end
else
if yy_act <= 87 then
if yy_act <= 73 then
if yy_act <= 66 then
if yy_act <= 62 then
if yy_act <= 60 then
if yy_act = 59 then
yy_set_line_column
--|#line 407

			set_last_token (SPACE)
		
else
yy_set_line_column
--|#line 423

			set_last_token (DOCTYPE_SYSTEM)
			last_value := system_literal_text
		
end
else
if yy_act = 61 then
yy_set_line_column
--|#line 428

			set_last_token (DOCTYPE_PUBLIC)
			last_value := system_literal_text
		
else
yy_set_line_column
--|#line 433

			set_last_token (DOCTYPE_SYSTEM)
			last_value := system_literal_text
		
end
end
else
if yy_act <= 64 then
if yy_act = 63 then
	yy_column := yy_column + 1
--|#line 441
 set_last_token (DOCTYPE_GROUP_OR) 
else
	yy_column := yy_column + 1
--|#line 442
 set_last_token (DOCTYPE_GROUP_SEQ) 
end
else
if yy_act = 65 then
	yy_column := yy_column + 1
--|#line 443
 set_last_token (DOCTYPE_GROUP_START) 
else
	yy_column := yy_column + 1
--|#line 444
 set_last_token (DOCTYPE_GROUP_END) 
end
end
end
else
if yy_act <= 70 then
if yy_act <= 68 then
if yy_act = 67 then
	yy_column := yy_column + 1
--|#line 445
 set_last_token (DOCTYPE_GROUP_ZEROMORE) 
else
	yy_column := yy_column + 1
--|#line 446
 set_last_token (DOCTYPE_GROUP_ANY) 
end
else
if yy_act = 69 then
	yy_column := yy_column + 1
--|#line 447
 set_last_token (DOCTYPE_GROUP_ONEMORE) 
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 449

			set_last_token (NMTOKEN) 
			last_value := text
		
end
end
else
if yy_act <= 72 then
if yy_act = 71 then
	yy_column := yy_column + 1
--|#line 457
 
			set_last_token (DOCTYPE_PERCENT) 
		
else
	yy_column := yy_column + 1
--|#line 460

			set_last_token (VALUE_START)
			push_start_condition (entity_value_single)
		
end
else
	yy_column := yy_column + 1
--|#line 464

			set_last_token (VALUE_START)
			push_start_condition (entity_value_double)
		
end
end
end
else
if yy_act <= 80 then
if yy_act <= 77 then
if yy_act <= 75 then
if yy_act = 74 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 472

			set_last_token (DOCTYPE_PEREFERENCE)
			last_value := text_substring (2, text_count - 1)
		
else
	yy_column := yy_column + 1
--|#line 476

			set_last_token (ENTITY_INVALID)
		
end
else
if yy_act = 76 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 483

			set_last_token (ENTITYVALUE_PEREFERENCE)
			last_value := text_substring (2, text_count - 1)
		
else
	yy_column := yy_column + 1
--|#line 491

			set_last_token (ENTITY_INVALID)
		
end
end
else
if yy_act <= 79 then
if yy_act = 78 then
	yy_column := yy_column + 2
--|#line 498

	set_last_token (TAG_START_END)
	push_start_condition (tag)

else
	yy_column := yy_column + 1
--|#line 503

	set_last_token (TAG_START)
	push_start_condition (tag)

end
else
yy_set_line_column
--|#line 510

			set_last_token (TAG_END_EMPTY)
			pop_start_condition
		
end
end
else
if yy_act <= 84 then
if yy_act <= 82 then
if yy_act = 81 then
yy_set_line_column
--|#line 515
 
			set_last_token (TAG_END) 
			pop_start_condition
		
else
	yy_column := yy_column + 1
--|#line 521

			 set_last_token (TAG_NAME_COLON) 
		
end
else
if yy_act = 83 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 524
 
			set_last_token (TAG_NAME_FIRST)
			last_value := text
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 528
 
			set_last_token (TAG_NAME_ATOM) 
			last_value := text
		
end
end
else
if yy_act <= 86 then
if yy_act = 85 then
yy_set_line_column
--|#line 532

			set_last_token (SPACE) 
		
else
yy_set_line_column
--|#line 535

			set_last_token (EQ) 
		
end
else
	yy_column := yy_column + 1
--|#line 539
 
			set_last_token (VALUE_START) 
			push_start_condition (attribute_value_single)
		
end
end
end
end
else
if yy_act <= 101 then
if yy_act <= 94 then
if yy_act <= 91 then
if yy_act <= 89 then
if yy_act = 88 then
	yy_column := yy_column + 1
--|#line 543

			set_last_token (VALUE_START)
			push_start_condition (attribute_value_double)
		
else
	yy_column := yy_column + 6
--|#line 557

				set_last_token (CHARDATA)
				last_value := "%'"
			
end
else
if yy_act = 90 then
	yy_column := yy_column + 6
--|#line 561

				set_last_token (CHARDATA)
				last_value := "%""
			
else
	yy_column := yy_column + 4
--|#line 565

				set_last_token (CHARDATA)
				last_value := "<"
			
end
end
else
if yy_act <= 93 then
if yy_act = 92 then
	yy_column := yy_column + 4
--|#line 569

				set_last_token (CHARDATA)
				last_value := ">"
			
else
	yy_column := yy_column + 5
--|#line 573

				set_last_token (CHARDATA)
				last_value := "&"
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 581
 
				set_last_token (CONTENT_ENTITY) 
				last_value := text_substring (2, text_count - 1)
			
end
end
else
if yy_act <= 98 then
if yy_act <= 96 then
if yy_act = 95 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 589
 
				set_last_token (CHARDATA) -- Bypassed
				last_value := text
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 596

			set_last_token (CHARDATA)
			last_value := text
		
end
else
if yy_act = 97 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 604
 
				set_last_token (ATTRIBUTE_ENTITY)
				last_value := text_substring (2, text_count - 1)
			
else
	yy_column := yy_column + 1
--|#line 609

			set_last_token (ATTRIBUTE_LT) -- conformance error
			last_value := text
		
end
end
else
if yy_act <= 100 then
if yy_act = 99 then
yy_set_line_column
--|#line 613

			-- XML1.0:3.3.3 Attribute value normalisation
			set_last_token (CHARDATA)
			last_value := Normalized_space
		
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 623
 
			character_entity.from_decimal (text_substring (3, text_count -	1))
			if character_entity.is_valid then
				set_last_token (CHARDATA)
				last_value := character_entity.as_string
			else
				set_last_token (ENTITY_INVALID)
			end
		
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 633

			character_entity.from_hexadecimal (text_substring (4, text_count -	1))
			if character_entity.is_valid then
				set_last_token (CHARDATA)
				last_value := character_entity.as_string
			else
				set_last_token (ENTITY_INVALID)
			end
		
end
end
end
else
if yy_act <= 108 then
if yy_act <= 105 then
if yy_act <= 103 then
if yy_act = 102 then
	yy_column := yy_column + 1
--|#line 643

			set_last_token (ENTITY_INVALID)
			last_value := text
		
else
	yy_column := yy_column + 1
--|#line 651
 
			set_last_token (VALUE_END) 
			pop_start_condition
		
end
else
if yy_act = 104 then
yy_set_line_column
--|#line 655

			-- after apos
			set_last_token (CHARDATA) 
			last_value := text
		
else
	yy_column := yy_column + 1
--|#line 664

			set_last_token (VALUE_END)
			pop_start_condition
		
end
end
else
if yy_act <= 107 then
if yy_act = 106 then
yy_set_line_column
--|#line 668

			-- after quot
			set_last_token (CHARDATA) 
			last_value := text
		
else
	yy_column := yy_column + 3
--|#line 677

	-- XML1.0:14 ]]> not allowed in markup
	last_token := CONTENT_CONDITIONAL_END
	last_value := text

end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 683

	 -- end of line handling XML1.0:2.11
	set_last_token (SPACE)
	last_value := Normalized_newline

end
end
else
if yy_act <= 112 then
if yy_act <= 110 then
if yy_act = 109 then
	yy_column := yy_column + 1
--|#line 689
 
	set_last_token (SPACE) 
	last_value := Normalized_newline

else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 694

	set_last_token (SPACE) 
	last_value := Normalized_newline

end
else
if yy_act = 111 then
yy_set_line_column
--|#line 699

	-- space not matched by newline normalization
	set_last_token (SPACE)
	last_value := text

else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 705
 
	-- get more than one at a time. could be more formal...
	set_last_token (CHARDATA)
	last_value := text

end
end
else
if yy_act <= 114 then
if yy_act = 113 then
yy_set_line_column
--|#line 711
 
	-- catch remaining correct characters
	set_last_token (CHARDATA) 
	last_value := text

else
	yy_column := yy_column + 1
--|#line 717

	-- default rule
	set_last_token (INPUT_INVALID)
	last_value := text

end
else
yy_set_line_column
--|#line 0
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			terminate
		end

feature {NONE} -- Table templates

	yy_nxt_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,   36,   37,   38,   39,   37,   36,   37,   38,   39,
			   37,   41,   36,   44,   45,   44,   41,   36,   44,   45,
			   44,   36,   74,   75,   74,   74,   36,  481,   86,   47,
			  140,   77,   78,   42,   47,   87,   88,   78,   42,   36,
			  481,   86,  481,  481,  141,   36,  177,   89,   87,   88,
			   78,   83,  178,   79,   90,   91,  131,  131,  131,  131,
			  142,  481,   43,  131,  131,  131,  131,   43,   36,   48,
			   49,   48,   48,   50,   50,   50,   50,   50,   50,   50,
			   50,   50,   50,   50,   50,   51,   51,   50,   51,   51,
			   51,   51,   51,   51,   51,   51,   51,   51,   52,   50,

			   50,   50,   50,   53,   52,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   50,   50,   50,
			   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
			   52,   50,   52,   54,   55,   54,   54,   54,   55,   54,
			   54,  466,   36,   60,   61,   60,   60,   36,   60,   61,
			   60,   60,   60,  131,  132,  131,  131,   60,   36,   74,
			   75,   74,   74,  146,  146,  146,  146,   56,   77,   78,
			  176,   56,  466,  206,   60,  146,  146,  146,  146,   60,

			  424,  425,   36,   80,   81,   80,   80,   36,   83,   89,
			   79,  201,   84,   83,  202,  207,   90,   91,   57,  193,
			  142,  194,   57,   63,  150,  150,  150,  150,   63,   58,
			  426,  427,   59,   58,   85,  208,   59,   36,   64,   65,
			   64,   64,   36,   66,   36,   36,   36,   36,   67,   36,
			   36,   36,   36,   36,   68,   68,   69,   68,   68,   68,
			   68,   68,   68,   68,   68,   68,   68,   70,   36,   36,
			   71,   72,   36,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   36,   36,   36,   73,

			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   36,   73,   36,   80,   81,   80,   80,  218,   83,  261,
			  219,  462,   84,  150,  150,  150,  150,  159,  159,  159,
			  159,  164,  164,  164,  164,  164,  164,  164,  164,  164,
			  164,  164,  164,  261,   85,   36,   92,   93,   92,   92,
			   36,   36,   36,   36,   94,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   95,   36,   96,   36,   97,
			   36,   95,   95,   95,   95,   95,   95,   95,   95,   98,

			   95,   95,   95,   95,   95,   99,   95,   95,  100,   95,
			   95,   95,   95,   95,  101,   36,  102,   95,   95,   95,
			   95,   95,   95,   95,   95,   95,   95,   95,   95,   95,
			   95,   95,   95,   95,   95,   95,   95,   95,   36,   95,
			   36,   36,  164,  164,  164,  164,  261,  116,  117,  275,
			  462,  276,  118,  209,  157,  157,  157,  157,  173,  173,
			  173,  173,  461,   36,   36,  173,  173,  173,  173,  462,
			  262,  187,  158,  465,  188,   95,   95,  111,  210,  119,
			  466,  120,  189,  428,  429,  121,  159,  160,  480,  122,
			  103,  103,   36,   36,   36,   92,   93,   92,   92,   36,

			   36,  104,   36,   94,   36,   36,  105,  106,  107,  108,
			  109,  110,  110,   36,  110,  110,  110,  110,  110,  110,
			  110,  110,  110,  110,  111,   36,   36,   36,   97,  112,
			  113,  111,  111,  111,  114,  111,  111,  111,  111,  111,
			  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
			  111,  111,  111,   36,   36,   36,  111,  111,  111,  111,
			  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
			  111,  111,  111,  111,  111,  111,  111,  115,  111,  116,
			  117,   36,  123,  299,  118,  124,  299,  125,  123,  354,
			  479,  124,   36,  125,  415,  417,   36,   36,  128,  128,

			  134,  478,  355,  477,   36,  430,  431,  299,   36,  111,
			  300,  119,  134,  120,   36,   36,   95,  121,  416,  418,
			   95,  122,  134,  476,  126,  476,   95,   95,  129,  129,
			  126,   36,  475,   36,  472,   36,  466,   36,  474,  473,
			  472,   36,   36,   36,   36,  462,  157,  157,  157,  157,
			  131,  131,  131,  131,  471,  136,  445,  130,  130,  470,
			  468,  137,  469,  138,  158,  468,  446,  166,  139,  131,
			  131,  131,  131,  167,  447,  168,  467,  166,  159,  160,
			  169,  464,  463,  167,  448,  168,  146,  146,  146,  146,
			  169,  198,  198,  198,  198,  198,  198,  198,  198,  198,

			  198,  150,  150,  150,  150,  157,  157,  157,  157,  159,
			  159,  159,  159,  164,  164,  164,  164,  173,  173,  173,
			  173,  460,  459,  158,  198,  198,  198,  224,  198,  198,
			  198,  198,  198,  198,  458,  457,  456,  159,  160,  198,
			  198,  198,  198,  198,  198,  198,  198,  198,  198,  308,
			  251,  454,  199,  481,  309,  455,  454,  453,  293,  333,
			  333,  333,  333,  135,  135,  451,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  452,  200,  481,  335,
			  335,  335,  335,  451,  450,  225,  449,  449,  165,  165,
			  444,  165,  165,  165,  165,  165,  165,  165,  165,  165,

			  165,  443,  217,  170,  170,  442,  170,  170,  170,  170,
			  170,  170,  170,  170,  170,  170,  441,  223,  481,  440,
			  439,  438,  333,  333,  333,  333,  437,  436,  172,  172,
			  436,  172,  172,  172,  172,  172,  172,  172,  172,  172,
			  172,  206,  226,  174,  174,  435,  174,  174,  174,  174,
			  174,  174,  174,  174,  174,  174,  334,  227,  434,  421,
			  228,  420,  413,  412,  229,  370,  370,  370,  370,  411,
			  410,  407,  230,  198,  198,  198,  198,  271,  198,  198,
			  198,  198,  272,  231,  251,  198,  198,  198,  198,  198,
			  198,  198,  198,  198,  198,  406,  307,  198,  198,  198,

			  198,  198,  198,  198,  198,  198,  198,  406,  307,  335,
			  335,  335,  335,  371,  371,  371,  371,  364,  364,  364,
			  364,  370,  370,  370,  370,  405,  387,  371,  371,  371,
			  371,  388,  389,  380,  380,  380,  380,  390,  414,  414,
			  414,  414,  405,  334,  404,  382,  382,  382,  382,  382,
			  400,  398,  398,  398,  398,  401,  408,  410,  410,  410,
			  410,  409,  403,  402,  399,  398,  414,  414,  414,  414,
			  397,  422,  419,  419,  419,  419,  423,  432,  396,  395,
			  394,  393,  433,  392,  391,  386,  385,  384,  383,  419,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,

			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
			   46,   46,   46,   46,   46,   46,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
			   36,   36,   36,   36,   36,   36,   36,   36,   36,   62,
			   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,

			   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
			   62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
			   62,   62,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   82,   82,   82,   82,   82,
			   82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
			   82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
			   82,   82,   82,   82,   82,   82,   82,   82,  127,  127,
			  127,  127,  127,  127,  127,  127,  127,  127,  127,  127,

			  127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
			  127,  127,  127,  127,  127,  127,  127,  127,  127,  127,
			  127,  133,  133,  133,  381,  133,  133,  133,  133,  133,
			  133,  133,  133,  133,  380,  133,  133,  133,  133,  133,
			  133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
			  135,  379,  252,  252,  252,  252,  252,  252,  378,  377,
			  135,  252,  376,  135,  135,  135,  135,  135,  135,  135,
			  135,  135,  375,  135,  135,  135,  135,  144,  144,  144,
			  144,  144,  374,  144,  144,  144,  144,  144,  144,  144,
			  144,  144,  144,  144,  144,  144,  144,  144,  144,  144,

			  144,  144,  144,  144,  144,  144,  144,  147,  147,  147,
			  147,  147,  147,  147,  147,  147,  373,  372,  147,  147,
			  147,  147,  147,  147,  147,  147,  147,  369,  147,  147,
			  147,  147,  148,  148,  148,  148,  148,  148,  148,  148,
			  148,  368,  367,  148,  148,  148,  148,  148,  148,  148,
			  148,  148,  366,  148,  148,  148,  148,  155,  155,  155,
			  365,  155,  155,  155,  155,  155,  155,  155,  155,  155,
			  364,  155,  155,  155,  155,  155,  155,  155,  155,  155,
			  155,  155,  155,  155,  155,  155,  161,  161,  161,  161,
			  161,  161,  161,  161,  363,  362,  361,  161,  161,  161,

			  161,  161,  161,  161,  161,  161,  360,  161,  161,  161,
			  161,  163,  163,  163,  163,  163,  163,  163,  163,  359,
			  358,  357,  163,  163,  163,  163,  163,  163,  163,  163,
			  163,  356,  163,  163,  163,  163,  165,  353,  352,  351,
			  350,  349,  348,  347,  346,  345,  165,  344,  343,  165,
			  165,  165,  165,  165,  165,  165,  165,  165,  342,  165,
			  165,  165,  165,  170,  341,  341,  170,  170,  170,  170,
			  170,  170,  170,  170,  170,  340,  170,  170,  170,  170,
			  172,  339,  338,  337,  336,  332,  331,  330,  329,  328,
			  172,  327,  326,  172,  172,  172,  172,  172,  172,  172,

			  172,  172,  325,  172,  172,  172,  172,  174,  324,  323,
			  174,  174,  174,  174,  174,  174,  174,  174,  174,  322,
			  174,  174,  174,  174,  175,  175,  175,  175,  175,  175,
			  175,  175,  175,  321,  320,  175,  175,  175,  175,  175,
			  175,  175,  175,  175,  319,  175,  175,  175,  175,  183,
			  183,  183,  183,  183,  183,  183,  183,  183,  318,  317,
			  183,  183,  183,  183,  183,  183,  183,  183,  183,  316,
			  183,  183,  183,  183,  184,  184,  184,  184,  184,  184,
			  184,  184,  184,  315,  314,  184,  184,  184,  184,  184,
			  184,  184,  184,  184,  313,  184,  184,  184,  184,  387,

			  387,  387,  387,  387,  312,  387,  387,  387,  387,  387,
			  387,  387,  387,  387,  311,  310,  387,  387,  387,  387,
			  387,  387,  387,  387,  387,  306,  387,  387,  387,  388,
			  388,  388,  305,  388,  304,  388,  388,  388,  388,  388,
			  388,  388,  388,  388,  303,  302,  388,  388,  388,  388,
			  388,  388,  388,  388,  388,  301,  388,  388,  388,  389,
			  389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
			  389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
			  389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
			  389,  390,  390,  390,  390,  390,  390,  390,  390,  390,

			  390,  390,  390,  390,  390,  390,  390,  390,  390,  390,
			  390,  390,  390,  390,  390,  390,  390,  390,  390,  390,
			  390,  390,  390,  422,  422,  422,  422,  422,  422,  422,
			  422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
			  422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
			  422,  422,  422,  422,  422,  423,  423,  423,  423,  423,
			  423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
			  423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
			  423,  423,  423,  423,  423,  423,  423,  298,  297,  296,
			  295,  294,  293,  292,  291,  290,  289,  288,  287,  286,

			  285,  284,  283,  282,  281,  280,  279,  278,  277,  274,
			  273,  270,  269,  268,  267,  266,  265,  264,  263,  260,
			  259,  258,  257,  256,  255,  254,  253,  250,  249,  248,
			  247,  246,  245,  244,  243,  242,  241,  240,  239,  238,
			  237,  236,  235,  234,  233,  232,  222,  221,  220,  162,
			  216,  215,  214,  213,  212,  211,  205,  204,  203,  197,
			  196,  195,  192,  191,  190,  186,  185,  182,  181,  180,
			  179,  171,  171,  162,  156,  154,  153,  152,  151,  149,
			  145,  143,  481,   35,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481>>)
		end

	yy_chk_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    2,    2,    2,    2,
			    2,    1,    3,    3,    3,    3,    2,    4,    4,    4,
			    4,   13,   13,   13,   13,   13,   17,    0,   17,    3,
			   42,   13,   13,    1,    4,   17,   17,   17,    2,   18,
			    0,   18,    0,    0,   42,   19,   98,   19,   18,   18,
			   18,   19,   98,   13,   19,   19,   37,   37,   37,   37,
			   42,    0,    1,   38,   38,   38,   38,    2,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    7,    7,    7,    7,    8,    8,    8,
			    8,  480,    9,    9,    9,    9,    9,   10,   10,   10,
			   10,   10,    9,   39,   39,   39,   39,   10,   14,   14,
			   14,   14,   14,   48,   48,   48,   48,    7,   14,   14,
			   96,    8,  479,  140,    9,   49,   49,   49,   49,   10,

			  415,  415,   15,   15,   15,   15,   15,   20,   15,   20,
			   14,  136,   15,   20,  136,  140,   20,   20,    7,  122,
			   96,  122,    8,    9,   54,   54,   54,   54,   10,    7,
			  416,  416,    7,    8,   15,  140,    8,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
			   11,   11,   16,   16,   16,   16,   16,  166,   16,  209,
			  166,  478,   16,   55,   55,   55,   55,   71,   71,   71,
			   71,   74,   74,   74,   74,   75,   75,   75,   75,   80,
			   80,   80,   80,  209,   16,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
			   23,   24,   81,   81,   81,   81,  210,   27,   27,  229,
			  477,  229,   27,  142,   64,   64,   64,   64,   92,   92,
			   92,   92,  451,   23,   24,   93,   93,   93,   93,  451,
			  210,  117,   64,  454,  117,   23,   24,   27,  142,   27,
			  454,   27,  117,  417,  417,   27,   64,   64,  475,   27,
			   23,   24,   23,   24,   25,   25,   25,   25,   25,   25,

			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
			   25,   25,   25,   25,   25,   25,   25,   25,   25,   28,
			   28,   31,   29,  261,   28,   29,  262,   29,   30,  324,
			  474,   30,   32,   30,  408,  409,   33,   34,   33,   34,

			   41,  473,  324,  471,   31,  418,  418,  261,   29,   28,
			  262,   28,   77,   28,   30,   32,   31,   28,  408,  409,
			   29,   28,   84,  470,   29,  469,   30,   32,   33,   34,
			   30,   31,  467,   31,  466,   29,  465,   29,  464,  463,
			  462,   30,   32,   30,   32,  461,   65,   65,   65,   65,
			  131,  131,  131,  131,  460,   41,  432,   33,   34,  459,
			  458,   41,  457,   41,   65,  456,  432,   77,   41,  132,
			  132,  132,  132,   77,  433,   77,  455,   84,   65,   65,
			   77,  453,  452,   84,  433,   84,  146,  146,  146,  146,
			   84,  134,  134,  134,  134,  134,  134,  134,  134,  134,

			  134,  150,  150,  150,  150,  157,  157,  157,  157,  159,
			  159,  159,  159,  164,  164,  164,  164,  173,  173,  173,
			  173,  450,  448,  157,  171,  171,  171,  171,  171,  171,
			  171,  171,  171,  171,  447,  446,  445,  157,  157,  198,
			  198,  198,  198,  198,  198,  198,  198,  198,  198,  273,
			  198,  444,  134,  135,  273,  443,  442,  441,  273,  333,
			  333,  333,  333,  135,  135,  440,  135,  135,  135,  135,
			  135,  135,  135,  135,  135,  135,  439,  135,  165,  335,
			  335,  335,  335,  438,  437,  171,  435,  434,  165,  165,
			  431,  165,  165,  165,  165,  165,  165,  165,  165,  165,

			  165,  430,  165,  170,  170,  429,  170,  170,  170,  170,
			  170,  170,  170,  170,  170,  170,  428,  170,  172,  427,
			  426,  425,  299,  299,  299,  299,  424,  423,  172,  172,
			  422,  172,  172,  172,  172,  172,  172,  172,  172,  172,
			  172,  176,  172,  174,  174,  421,  174,  174,  174,  174,
			  174,  174,  174,  174,  174,  174,  299,  174,  420,  412,
			  176,  411,  404,  401,  176,  348,  348,  348,  348,  400,
			  399,  392,  176,  224,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  176,  224,  271,  271,  271,  271,  271,
			  271,  271,  271,  271,  271,  390,  271,  272,  272,  272,

			  272,  272,  272,  272,  272,  272,  272,  389,  272,  300,
			  300,  300,  300,  349,  349,  349,  349,  364,  364,  364,
			  364,  370,  370,  370,  370,  388,  370,  371,  371,  371,
			  371,  370,  371,  380,  380,  380,  380,  371,  405,  405,
			  405,  405,  387,  300,  386,  382,  382,  382,  382,  364,
			  382,  398,  398,  398,  398,  382,  398,  410,  410,  410,
			  410,  398,  384,  383,  381,  380,  414,  414,  414,  414,
			  379,  414,  419,  419,  419,  419,  414,  419,  378,  377,
			  376,  375,  419,  374,  373,  368,  367,  366,  365,  410,
			  482,  482,  482,  482,  482,  482,  482,  482,  482,  482,

			  482,  482,  482,  482,  482,  482,  482,  482,  482,  482,
			  482,  482,  482,  482,  482,  482,  482,  482,  482,  482,
			  482,  482,  482,  483,  483,  483,  483,  483,  483,  483,
			  483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
			  483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
			  483,  483,  483,  483,  483,  483,  484,  484,  484,  484,
			  484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
			  484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
			  484,  484,  484,  484,  484,  484,  484,  484,  484,  485,
			  485,  485,  485,  485,  485,  485,  485,  485,  485,  485,

			  485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
			  485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
			  485,  485,  486,  486,  486,  486,  486,  486,  486,  486,
			  486,  486,  486,  486,  486,  486,  486,  486,  486,  486,
			  486,  486,  486,  486,  486,  486,  486,  486,  486,  486,
			  486,  486,  486,  486,  486,  487,  487,  487,  487,  487,
			  487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
			  487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
			  487,  487,  487,  487,  487,  487,  487,  487,  488,  488,
			  488,  488,  488,  488,  488,  488,  488,  488,  488,  488,

			  488,  488,  488,  488,  488,  488,  488,  488,  488,  488,
			  488,  488,  488,  488,  488,  488,  488,  488,  488,  488,
			  488,  489,  489,  489,  363,  489,  489,  489,  489,  489,
			  489,  489,  489,  489,  362,  489,  489,  489,  489,  489,
			  489,  489,  489,  489,  489,  489,  489,  489,  489,  489,
			  490,  360,  504,  504,  504,  504,  504,  504,  359,  358,
			  490,  504,  357,  490,  490,  490,  490,  490,  490,  490,
			  490,  490,  354,  490,  490,  490,  490,  491,  491,  491,
			  491,  491,  353,  491,  491,  491,  491,  491,  491,  491,
			  491,  491,  491,  491,  491,  491,  491,  491,  491,  491,

			  491,  491,  491,  491,  491,  491,  491,  492,  492,  492,
			  492,  492,  492,  492,  492,  492,  352,  350,  492,  492,
			  492,  492,  492,  492,  492,  492,  492,  347,  492,  492,
			  492,  492,  493,  493,  493,  493,  493,  493,  493,  493,
			  493,  345,  344,  493,  493,  493,  493,  493,  493,  493,
			  493,  493,  343,  493,  493,  493,  493,  494,  494,  494,
			  342,  494,  494,  494,  494,  494,  494,  494,  494,  494,
			  338,  494,  494,  494,  494,  494,  494,  494,  494,  494,
			  494,  494,  494,  494,  494,  494,  495,  495,  495,  495,
			  495,  495,  495,  495,  337,  336,  334,  495,  495,  495,

			  495,  495,  495,  495,  495,  495,  332,  495,  495,  495,
			  495,  496,  496,  496,  496,  496,  496,  496,  496,  331,
			  327,  326,  496,  496,  496,  496,  496,  496,  496,  496,
			  496,  325,  496,  496,  496,  496,  497,  322,  321,  320,
			  318,  317,  316,  315,  314,  313,  497,  312,  311,  497,
			  497,  497,  497,  497,  497,  497,  497,  497,  310,  497,
			  497,  497,  497,  498,  309,  308,  498,  498,  498,  498,
			  498,  498,  498,  498,  498,  306,  498,  498,  498,  498,
			  499,  305,  303,  302,  301,  298,  297,  296,  295,  292,
			  499,  291,  290,  499,  499,  499,  499,  499,  499,  499,

			  499,  499,  289,  499,  499,  499,  499,  500,  288,  287,
			  500,  500,  500,  500,  500,  500,  500,  500,  500,  286,
			  500,  500,  500,  500,  501,  501,  501,  501,  501,  501,
			  501,  501,  501,  285,  284,  501,  501,  501,  501,  501,
			  501,  501,  501,  501,  283,  501,  501,  501,  501,  502,
			  502,  502,  502,  502,  502,  502,  502,  502,  282,  281,
			  502,  502,  502,  502,  502,  502,  502,  502,  502,  280,
			  502,  502,  502,  502,  503,  503,  503,  503,  503,  503,
			  503,  503,  503,  279,  278,  503,  503,  503,  503,  503,
			  503,  503,  503,  503,  277,  503,  503,  503,  503,  505,

			  505,  505,  505,  505,  276,  505,  505,  505,  505,  505,
			  505,  505,  505,  505,  275,  274,  505,  505,  505,  505,
			  505,  505,  505,  505,  505,  270,  505,  505,  505,  506,
			  506,  506,  267,  506,  266,  506,  506,  506,  506,  506,
			  506,  506,  506,  506,  265,  264,  506,  506,  506,  506,
			  506,  506,  506,  506,  506,  263,  506,  506,  506,  507,
			  507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
			  507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
			  507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
			  507,  508,  508,  508,  508,  508,  508,  508,  508,  508,

			  508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
			  508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
			  508,  508,  508,  509,  509,  509,  509,  509,  509,  509,
			  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
			  509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
			  509,  509,  509,  509,  509,  510,  510,  510,  510,  510,
			  510,  510,  510,  510,  510,  510,  510,  510,  510,  510,
			  510,  510,  510,  510,  510,  510,  510,  510,  510,  510,
			  510,  510,  510,  510,  510,  510,  510,  260,  259,  257,
			  254,  253,  252,  248,  247,  246,  245,  244,  243,  242,

			  241,  240,  239,  237,  235,  234,  233,  232,  230,  228,
			  225,  222,  221,  220,  219,  218,  215,  214,  213,  208,
			  207,  206,  205,  204,  203,  202,  201,  197,  196,  195,
			  194,  193,  192,  191,  190,  189,  188,  187,  186,  185,
			  182,  181,  180,  179,  178,  177,  169,  168,  167,  158,
			  156,  154,  153,  152,  145,  143,  139,  138,  137,  130,
			  129,  126,  121,  120,  119,  114,  113,  104,  102,  100,
			   99,   91,   88,   69,   63,   59,   58,   57,   56,   53,
			   47,   43,   35,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481>>)
		end

	yy_base_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    5,   11,   16,   67,    0,  151,  155,  161,
			  166,  236,    0,   20,  177,  201,  321,   25,   38,   44,
			  206,  354,    0,  430,  431,  493,    0,  440,  572,  575,
			  581,  571,  582,  595,  596, 1882, 1883,   54,   61,  171,
			    0,  592,   24, 1819, 1883, 1883,    0, 1862,  181,  193,
			 1883,    0,    0, 1844,  222,  331, 1843, 1804, 1797, 1808,
			 1883, 1883,    0, 1812,  452,  644, 1883, 1883,    0, 1838,
			 1883,  335, 1883,    0,  339,  343, 1883,  604, 1883, 1883,
			  347,  440, 1883, 1883,  614, 1883, 1883,    0, 1864, 1883,
			    0, 1863,  456,  463,    0,    0,  184, 1883,    3, 1814,

			 1811, 1883, 1806, 1883, 1816, 1883, 1883, 1883, 1883, 1883,
			    0,    0, 1883, 1817, 1817, 1883, 1883,  429, 1883, 1824,
			 1814, 1822,  171, 1883, 1883, 1883, 1821, 1883, 1883, 1854,
			 1797,  648,  667,    0,  670,  745,  139, 1779, 1778, 1776,
			  175, 1883,  396, 1820,    0, 1819,  684,    0,    0, 1883,
			  699, 1883, 1788, 1789, 1774,    0, 1815,  703, 1814,  707,
			 1883,    0, 1883,    0,  711,  770,  255, 1769, 1768, 1766,
			  785,  703,  810,  715,  825,    0,  823, 1796, 1805, 1805,
			 1788, 1806, 1801,    0,    0, 1781, 1787, 1792, 1788, 1794,
			 1797, 1778, 1779, 1776, 1775, 1792, 1768, 1792,  718,    0,

			 1883, 1751, 1751, 1792, 1791, 1748, 1803, 1770, 1780,  281,
			  398, 1883, 1883, 1744, 1744, 1738, 1883, 1883, 1740, 1740,
			 1781, 1780, 1737, 1883,  852, 1787, 1883, 1883, 1754,  402,
			 1758, 1883, 1757, 1759, 1758, 1749, 1883, 1763,    0, 1747,
			 1744, 1749, 1747, 1743, 1752, 1755, 1745, 1757, 1738, 1883,
			 1883, 1883, 1760, 1759, 1712, 1883, 1883, 1710, 1883, 1749,
			 1747,  536,  539, 1589, 1579, 1574, 1602, 1554, 1883, 1883,
			 1546,  864,  876,  726, 1560, 1573, 1549, 1539, 1531, 1527,
			 1524, 1518, 1521, 1486, 1493, 1486, 1463, 1472, 1453, 1460,
			 1446, 1436, 1452, 1883, 1883, 1456, 1455, 1431, 1448,  820,

			  907, 1414, 1420, 1408, 1883, 1449, 1443, 1883, 1433, 1432,
			 1411, 1400, 1402, 1408, 1403, 1403, 1403, 1393, 1385,    0,
			 1399, 1393, 1392,    0,  544, 1377, 1380, 1375,    0, 1883,
			 1883, 1361, 1351,  757, 1361,  777, 1322, 1323, 1297, 1883,
			 1883, 1883, 1315, 1311, 1287, 1286,    0, 1286,  863,  911,
			 1280, 1883, 1275, 1229, 1231,    0,    0, 1213, 1209, 1207,
			 1214, 1883, 1165, 1150,  915,  934,  938,  928,  940,    0,
			  919,  925, 1883,  944,  942,  927,  926,  930,  937,  910,
			  931,  891,  943,  908,  907, 1883,  894,  935,  913,  900,
			  883, 1883,  831,    0,    0,    0, 1883, 1883,  949,  803,

			  847,  841, 1883, 1883,  813,  936, 1883, 1883,  538,  539,
			  955,  842,  840, 1883,  964,  146,  152,  429,  527,  970,
			  837,  824,  823,  815,  808,  779,  802,  751,  798,  763,
			  783,  722,  583,  601,  780,  774, 1883,  747,  765,  713,
			  747,  720,  738,  692,  733,  662,  668,  660,  655, 1883,
			  667,  440,  604,  627,  451,  598,  658,  584,  648,  581,
			  615,  618,  633,  574,  599,  609,  622,  567, 1883,  618,
			  611,  558, 1883,  531,  545,  418, 1883,  405,  261,  147,
			   91, 1883,  989, 1022, 1055, 1088, 1121, 1154, 1187, 1216,
			 1243, 1273, 1298, 1323, 1352, 1377, 1402, 1429, 1446, 1473,

			 1490, 1515, 1540, 1565, 1241, 1596, 1626, 1657, 1689, 1721,
			 1753>>)
		end

	yy_def_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,  482,  482,  483,  483,  481,    5,  484,  484,  485,
			  485,  481,   11,  486,  486,  487,  487,  486,  486,  487,
			  487,  481,   21,   21,   21,  481,   25,   25,   25,   21,
			   21,   21,   21,  488,  488,  481,  481,  481,  481,  481,
			  489,  490,  481,  481,  481,  481,  491,  481,  481,  481,
			  481,  492,  493,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  494,  481,  481,  481,  481,  481,  495,  481,
			  481,  481,  481,  496,  481,  481,  481,  497,  481,  481,
			  481,  481,  481,  481,  497,  481,  481,  498,  499,  481,
			  498,  499,  481,  481,  500,  501,  481,  481,  501,  501,

			  501,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  502,  503,  481,  503,  503,  481,  481,  481,  481,  503,
			  503,  503,  503,  481,  481,  481,  501,  481,  481,  481,
			  481,  481,  481,  489,  481,  490,  135,  135,  135,  135,
			  481,  481,  481,  481,  491,  481,  481,  492,  493,  481,
			  481,  481,  481,  481,  481,  494,  481,  481,  481,  481,
			  481,  495,  481,  496,  481,  497,  165,  165,  165,  165,
			  498,  481,  499,  481,  500,  501,  481,  501,  501,  501,
			  501,  481,  481,  502,  503,  503,  503,  481,  481,  481,
			  503,  503,  503,  503,  503,  501,  481,  481,  481,  504,

			  481,  135,  135,  135,  135,  135,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  165,  165,
			  165,  165,  165,  481,  481,  504,  481,  481,  481,  481,
			  481,  481,  501,  501,  501,  501,  481,  481,  503,  503,
			  481,  481,  481,  503,  503,  503,  503,  503,  501,  481,
			  481,  481,  504,  135,  135,  481,  481,  135,  481,  481,
			  481,  481,  481,  481,  481,  481,  165,  165,  481,  481,
			  165,  481,  481,  504,  481,  481,  481,  481,  501,  501,
			  501,  501,  481,  503,  481,  481,  481,  503,  503,  503,
			  503,  503,  501,  481,  481,  135,  135,  481,  481,  481,

			  481,  481,  481,  481,  481,  165,  165,  481,  504,  504,
			  481,  481,  481,  481,  501,  501,  501,  501,  481,  503,
			  481,  481,  481,  503,  503,  503,  503,  503,  501,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  501,  501,  501,  501,
			  481,  481,  481,  481,  503,  503,  503,  503,  503,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  501,
			  481,  481,  481,  481,  481,  503,  503,  503,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  505,  506,  507,
			  508,  481,  481,  503,  503,  503,  481,  481,  481,  481,

			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  509,  510,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,    0,  481,  481,  481,  481,  481,  481,  481,  481,
			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,

			  481,  481,  481,  481,  481,  481,  481,  481,  481,  481,
			  481>>)
		end

	yy_ec_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    5,    6,    7,    8,    9,   10,   11,   12,
			   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
			   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
			   33,   34,   35,   36,    9,   37,   38,   39,   40,   41,
			   42,   43,   44,   45,   44,   46,   47,   48,   49,   50,
			   51,   52,   53,   54,   55,   56,   44,   44,   57,   58,
			   59,   60,   61,   62,   61,   44,   61,   63,   64,   65,

			   66,   67,   68,   69,   44,   70,   44,   44,   71,   72,
			   73,   74,   75,   76,   77,   78,   79,   80,   81,   44,
			   82,   83,   44,   61,   84,   61,   61,   61,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,

			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,    1>>)
		end

	yy_meta_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    3,    4,    5,    6,    7,    5,
			    5,    8,    5,    5,    5,    5,    5,    5,    9,   10,
			    5,   11,   11,   11,   11,   11,   12,   13,   14,   15,
			   16,   17,    5,   18,    5,   19,    5,   20,   20,   20,
			   20,   20,   20,   21,   21,   21,   21,   21,   21,   21,
			   21,   21,   21,   22,   23,   24,   25,   26,   27,   28,
			   19,   29,    8,   20,   20,   20,   20,   20,   20,   21,
			   21,   21,   21,   21,   21,   21,   30,   21,   21,   31,
			   21,   21,   21,   32,   19,   33>>)
		end

	yy_accept_template: ANY is
			-- This is supposed to be "like FIXED_INTEGER_ARRAY_TYPE",
			-- but once functions cannot be declared with anchored types.
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  116,  114,  111,  110,  109,
			  112,  102,   79,  113,    5,    5,    4,    5,   17,   17,
			   19,   18,   16,   19,   14,   14,  114,  114,  114,  114,
			   23,   23,   22,   23,   85,   85,   88,   87,   84,  114,
			   82,   86,   81,   83,   99,   99,  104,  102,  103,   98,
			   99,   99,  106,  105,  102,   98,  104,   77,  102,  106,
			   77,  102,   59,   59,   75,   58,  114,   57,   58,   58,

			   58,   40,   41,   39,  114,   65,   66,   68,   69,   64,
			   70,   58,   67,   58,   58,   63,   38,  114,   37,   58,
			   58,   58,   58,   73,   71,   72,   58,   52,   52,   52,
			   52,  111,  108,  112,    0,    0,    0,    0,    0,    0,
			    0,   78,    8,    0,    4,    3,   17,   18,   16,   15,
			   14,    9,    0,    0,    0,   22,    0,   85,    0,   86,
			   81,   84,   80,   83,   99,    0,    0,    0,    0,    0,
			    0,    0,    0,   59,    0,   58,    0,   58,   58,   58,
			   58,    0,    0,   70,   58,   58,   58,    0,    0,    0,
			   58,   58,   29,   58,   58,   58,    0,    0,    0,    0,

			   94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  107,    2,    0,    0,    0,   21,   97,    0,    0,
			    0,    0,    0,   76,    0,    0,   95,   74,    0,    0,
			    0,   48,   58,   58,   58,   58,   49,    0,   55,   58,
			    0,    0,    0,   58,   58,   58,   58,   58,   58,   50,
			   51,  100,    0,    0,    0,   92,   91,    0,    1,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,   92,   91,
			    0,    0,    0,    0,    0,    0,    0,    0,   58,   58,
			   58,   58,    0,   58,    0,    0,    0,   58,   58,   58,
			   58,   58,   58,  101,   93,    0,    0,    0,    0,    0,

			    0,    0,    0,    0,   93,    0,    0,   96,    0,    0,
			    0,    0,    0,    0,   58,   58,   58,   58,    0,   54,
			    0,    0,    0,   28,   58,   30,   58,   58,   56,   89,
			   90,    0,    0,    7,    0,    6,    0,    0,    0,   89,
			   90,   96,    0,    0,    0,    0,   46,   58,   58,   58,
			    0,   27,    0,    0,   58,   32,   31,   58,   58,    0,
			    0,    7,    0,    0,    0,    0,    0,    0,    0,   47,
			    0,    0,   53,    0,    0,   58,   34,   58,    0,    0,
			    0,    0,    0,    0,    0,   44,    0,    0,    0,    0,
			    0,   26,    0,   33,   35,   36,   24,   20,    0,    0,

			    0,    0,   43,   42,    0,   61,   62,   25,    0,    0,
			    0,    0,    0,   45,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,   60,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,   12,    0,
			    0,    0,   13,    0,    0,    0,   11,    0,    0,    0,
			    0,    0>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 1883
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 481
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 482
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 115
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 116
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	comment_state: INTEGER is 1
	processinginstruction: INTEGER is 2
	xmldeclaration: INTEGER is 3
	cdata: INTEGER is 4
	tag: INTEGER is 5
	attribute_value_single: INTEGER is 6
	attribute_value_double: INTEGER is 7
	entity_value_single: INTEGER is 8
	entity_value_double: INTEGER is 9
	doctype: INTEGER is 10
	dtd_in: INTEGER is 11
	dtd_element: INTEGER is 12
	dtd_attlist: INTEGER is 13
	dtd_entity: INTEGER is 14
	dtd_notation: INTEGER is 15
	dtd_ignore: INTEGER is 16
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Creation

	make_scanner is
			-- Initialise.
		do
			!! character_entity.make
			make_with_buffer (Empty_buffer)
			reset
		end
		
feature -- Reset

	push_start_condition_dtd_ignore is
		do
			push_start_condition (dtd_ignore)
		end
		
	reset is
			-- Reset.
		do
			Precursor
			filename := "-"
			last_error := Void
			!! start_conditions.make
		end
		
feature -- Input

	set_input_file (a_name: STRING) is
			-- Parse file.
			-- Set `last _input_file_opened' to status.
		require
			not_void: a_name /= Void
		local
			a_file: like INPUT_STREAM_TYPE
			a_buffer: NXML_UTF16_FILE_BUFFER
		do
			filename := a_name
			a_file := INPUT_STREAM_.make_file_open_read (filename)
			last_input_file_opened := INPUT_STREAM_.is_open_read (a_file)
			if last_input_file_opened then
				!! a_buffer.make (a_file)
				set_input_buffer (a_buffer)
			else
				fatal_error (Error_cannot_read_file)
			end
		ensure
			keep_copy: a_name = filename
		end
	
	fatal_error (a_message: STRING) is
			-- A fatal error occurred.
		do
			last_error := a_message
		end

	last_input_file_opened: BOOLEAN

feature -- Error reportring

	has_error: BOOLEAN is
			-- Was there an error?
		do
			Result := last_error /= Void
		end
		
	last_error: STRING
		
	filename: STRING
	
feature -- Last value

	last_value: ANY

feature {NONE} -- Character entity
	
	character_entity: NXML_CHARACTER_ENTITY
			-- Character entity manager (class once)
			
feature {NONE} -- Start condition stack

	push_start_condition (a_condition: INTEGER) is
			-- Set start condition and add previous to stack.
		do
			start_conditions.force (start_condition)
			set_start_condition (a_condition)
		end

	pop_start_condition is
			-- Restore previous start condition.
		do
			if not start_conditions.is_empty then
				-- this would be a precondtion save for 
				-- invalid input document
				set_start_condition (start_conditions.item)
				start_conditions.remove
			-- else error, later in parser hopefully
			end
		end

	start_conditions: DS_LINKED_STACK[INTEGER]

feature {NONE} -- System literal

	system_literal_text: STRING is
			-- Find last quoted substring in scanner text.
			-- (this is microparsing, justified above)
		require
			quote_at_end: text_item (text_count) = '%'' or text_item (text_count) = '%"'
			--quote_in: text_substring (1, text_count-1).has (text_item (text_count))
		local
			i: INTEGER
			a_quote: CHARACTER
		do
			from
				a_quote := text_item (text_count)
				i := text_count - 1
			invariant
				i >= 0
			variant
				i
			until
				text_item (i) = a_quote
			loop
				i := i - 1
			end
			Result := text_substring (i + 1, text_count - 1)
		end
		
feature {NONE} -- Constants

	Normalized_newline: STRING is once Result := "%N" end
	Normalized_space: STRING is once Result := " " end

invariant
	start_not_void: start_conditions /= Void
	character_entity_not_void: character_entity /= Void
	
end

