indexing
	description: "Scanner for external DTD"
	project: "http://www.nenie.org/eiffel/"
	implements: "XML 1.0 Second Edition - W3C Recommendation 6 October 2000 (referred as 'XML1.0')"
	noncompliance_unicode: "UTF8 is assumed and all chars >255 are assumed to be LETTERS"
	
class NXML_SCANNER_DTD

inherit
	NXML_SCANNER
		redefine
			make_scanner,
			read_token
		end
		
creation
	make_scanner
	
feature {NONE} -- Creation

	make_scanner is
			-- Make dtd scanner.
		do
			Precursor
			set_start_condition (doctype)
		end

feature {NONE} -- State

	decl_start_sent: BOOLEAN
	decl_end_sent: BOOLEAN
	
feature

	read_token is
			-- Horrible hack that places the content of an external 
			-- DTD within a (DOCTYPE_DECL_START, DOCTYPE_DECL_END)
			-- token pair.
		do
			debug ("nxml")
				io.put_string ("--dtd-scanner--")
				if has_error then io.put_string (last_error) end
			end
			if not decl_start_sent then
				set_last_token (DOCTYPE_DECLARATION_START)
				decl_start_sent := True
			elseif decl_end_sent then
				terminate
			else
				Precursor
				if end_of_file then
					set_last_token (DOCTYPE_DECLARATION_END)
					decl_end_sent := True
				end
			end
		end
		
end
